//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                                  БАЗОВЫЙ ТЕСТ №1
//    На консоль однократно выводится протокол по контроллеру и тесту. 
//    На консоль(монитор порта) выводятся значения ADC(по изменению),Кнопка(по изменению),быстродействие проекта-->все вместе периодически. 
//    На пин PWM выводится значение с ADC.      
//    На пин Led выводится меандр 500 мс.
//    На пин Control выводится изменение в каждом цикле loop(для логического анализатора).
//-------------------------------------------------------------------------------------------------
// Для настройки IDE для работы поддерживаемыми платами во вкладке Readme.hpp имеется инструкция и др.полезная информация. 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#include "RT_HW_BASE.h"  	//--Подключение базовой библиотеки (не обязательна, так как дублируется в других библиотеках ниже);
//=============================Подключение внутренних функций========================================
#include "Aobj.hpp"      	//--Объекты и переменные;
#include "Bfunc.hpp"  		//--Базовые функции;     
//=============================SETUP()===============================================================
void setup(){}
//=============================LOOP()================================================================
void loop(){
//-----------------------------Системные функции--------------------------------------------------- 
initProject();                                                                                     //--Настройка параметров;
RT_HW_Base.sheduler();                                                                             //--Работа с диспетчером;
if(RT_HW_Base.shed.eventSec){vSpeedMCU=RT_HW_Base.shed.cycle; vSpeedMCUF=filterSpeed.filtered(vSpeedMCU); //--Расчет быстродействия с фильтрацией; 
                             vSpeedSmall=round(((float)vSpeedMCUF)/1000);}                         //--Получение быстродействия/1000;
RT_HW_Base.consoleBegin();                                                                         //--Инициализация консоли;
if(RT_HW_Base.console.head){consoleHead();}                             //--Однократный вывод на консоль заголовка проекта;
RT_HW_Base.pinDigitalWrite(idPinControl,RT_HW_Base.device.pin.control,RT_HW_Base.shed.control);    //--Вывод loop() на контрольный пин;
RT_HW_Base.pinDigitalWrite(idPinLed,    RT_HW_Base.device.pin.led,    RT_HW_Base.shed.blink500);   //--Вывод меандра 500ms на Led; 
//=====================ПИНЫ========================================================================
if(RT_HW_Base.shed.fast.num==2) {fncADC();}       //--Чтение ADC [Быстрая задача, период 100ms, так как ADC на AVR не быстрый]; 
if(RT_HW_Base.shed.fast.num==2) {fncPWM();}       //--Запись PWM [Быстрая задача, период 100ms, так как ADC на AVR не быстрый]; 
if(RT_HW_Base.shed.frdm.num==4) {fncButton();}    //--Чтение кнопки с защитой от дребезга;
//=====================ВЫВОД НА КОНСОЛЬ============================================================
if(RT_HW_Base.shed.fast.num==1) {
if(cnt++>30)           {cnt=1;}
if(vAgoButton!=vButton){cnt=1;}
if(vAgoADC!=vADCF)     {cnt=1;}
if(first==0){if(vSpeedMCU>0){first=1; cnt=1;}}
if(cnt==1){vAgoButton=vButton; vAgoADC=vADCF;
           RT_HW_Base.consoleTest(String(F("Кнопка")),(uint8_t)vButton,';');
           RT_HW_Base.consoleTest(String(F(" ADC")),vADCF,';');
           RT_HW_Base.consoleTest(String(F(" Speed")),vSpeedMCUF); 
          }
}
//=================================================================================================
}; //++++END loop()================================================================================
   
