//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                                  ТЕСТ №2 Сканирование шины i2c
//    На консоль однократно выводится протокол по контроллеру и тесту. 
//    На консоль периодически выводится результаты сканирования шин i2c. 
//    На пин PWM выводится значение с ADC.      
//    На пин Led выводится меандр 500 мс.
//    На пин Control выводится изменение в каждом цикле loop(для логического анализатора).
//-------------------------------------------------------------------------------------------------
// Для настройки IDE для работы поддерживаемыми платами во вкладке Readme.hpp имеется инструкция и др.полезная информация. 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#include "RT_HW_BASE.h"         //--Подключение базовой библиотеки (не обязательна, так как дублируется в других библиотеках ниже);
//=============================Подключение внутренних функций========================================
#include "Aobj.hpp"       //--Объекты и переменные;
#include "Bfunc.hpp"      //--Базовые функции;     
//=============================SETUP()===============================================================
void setup(){}
//=============================LOOP()================================================================
void loop(){
//-----------------------------Системные функции--------------------------------------------------- 
initProject();                                                                                     //--Настройка параметров;
RT_HW_Base.sheduler();                                                                             //--Работа дисплея;
if(RT_HW_Base.shed.eventSec){vSpeedMCU=RT_HW_Base.shed.cycle; vSpeedMCUF=filterSpeed.filtered(vSpeedMCU); //--Расчет быстродействия с фильтрацией; 
                             vSpeedSmall=round(((float)vSpeedMCUF)/1000);}                         //--Получение быстродействия/1000;
RT_HW_Base.consoleBegin();                                                                         //--Инициализация консоли;
if(RT_HW_Base.console.head){consoleHead();}                             //--Однократный вывод на консоль заголовка проекта;
RT_HW_Base.pinDigitalWrite(idPinControl,RT_HW_Base.device.pin.control,RT_HW_Base.shed.control);    //--Вывод loop() на контрольный пин;
RT_HW_Base.pinDigitalWrite(idPinLed,    RT_HW_Base.device.pin.led,    RT_HW_Base.shed.blink500);   //--Вывод меандра 500ms на Led; 
//=====================ПИНЫ========================================================================
if(RT_HW_Base.shed.fast.num==2) {fncADC();}       //--Чтение ADC [Быстрая задача, период 100ms, так как ADC на AVR не быстрый]; 
if(RT_HW_Base.shed.fast.num==2) {fncPWM();}       //--Запись PWM [Быстрая задача, период 100ms, так как ADC на AVR не быстрый]; 
//=====================СКАНИРОВАНИЕ ШИН i2c=========================================================
//-----------------Сканирование шины i2c------------------------------------------------------------
if(RT_HW_Base.shed.frdm.num==1){
if(RT_HW_Base.generatorEvent(idGenScan,1500)){
   RT_HW_Base.i2cScanBus(0);
 //RT_HW_Base.i2cScanBus(1);  
}}
//=================================================================================================
}; //++++END loop()================================================================================
   
