#include "RT_HW_BASE.h"	 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							 СОЗДАНИЕ ВНЕШНИХ ОБЪЕКТОВ ДЛЯ UART
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++			

#if defined(RT_HW_CORE_STM32_D) || defined(RT_HW_CORE_SEEED) || defined(RT_HW_CORE_RP_PICO) || defined(RT_HW_CORE_ESP) //======UARTUSB 
#endif
#if defined(RT_HW_PERMIT_UART0) 								//====== UART0:(num=0) 
//--Объект Serial во всех CORE объявлен по умолчанию 			//--Объект Serial;
#endif
//#if defined(RT_HW_PERMIT_UART1) && (defined(RT_HW_CORE_STM32_D) && (!(defined(RT_HW_BOARD_D_BLACK_F407VE) || defined(RT_HW_BOARD_D_BLACK_F407VG))))
//HardwareSerial  		Serial1(RT_HW_UART1_RX,RT_HW_UART1_TX); //--Объект Serial;
//#endif
#if defined(RT_HW_PERMIT_UART1) && (defined(RT_HW_CORE_STM32_D) && (!defined(USART1)))
HardwareSerial  		Serial1(RT_HW_UART1_RX,RT_HW_UART1_TX); //--Объект Serial1;
#endif
#if defined(RT_HW_PERMIT_UART2) && (defined(RT_HW_CORE_STM32_D) && (!defined(USART2)))
HardwareSerial  		Serial2(RT_HW_UART2_RX,RT_HW_UART2_TX); //--Объект Serial2;
#endif
#if defined(RT_HW_PERMIT_UART3) && (defined(RT_HW_CORE_STM32_D) && (!defined(USART3)))
HardwareSerial  		Serial3(RT_HW_UART3_RX,RT_HW_UART3_TX); //--Объект Serial3;
#endif
#if defined(RT_HW_PERMIT_UART4) && (defined(RT_HW_CORE_STM32_D) && (!defined(USART4)))
HardwareSerial  		Serial4(RT_HW_UART4_RX,RT_HW_UART4_TX); //--Объект Serial4;
#endif
#if defined(RT_HW_PERMIT_UART5) && (defined(RT_HW_CORE_STM32_D) && (!defined(USART5)))
HardwareSerial  		Serial5(RT_HW_UART5_RX,RT_HW_UART5_TX); //--Объект Serial5;
#endif
#if defined(RT_HW_PERMIT_UART6) && (defined(RT_HW_CORE_STM32_D) && (!defined(USART4)))
HardwareSerial  		Serial6(RT_HW_UART6_RX,RT_HW_UART6_TX); //--Объект Serial6;
#endif

//#if defined(RT_HW_PERMIT_UART2) && defined(RT_HW_CORE_STM32_D)	//====== UART2:(num=2) 
//HardwareSerial  		Serial2(RT_HW_UART2_RX,RT_HW_UART2_TX);	//--Объект Serial2 для STM32D;
//#endif
//#if defined(RT_HW_PERMIT_UART3) && defined(RT_HW_CORE_STM32_D)	//====== UART3:(num=3)  
//HardwareSerial  		Serial3(RT_HW_UART3_RX,RT_HW_UART3_TX);	//--Объект Serial3 для STM32D
//#endif
//#if defined(RT_HW_PERMIT_UART4) && defined(RT_HW_CORE_STM32_D)	//====== UART4:(num=4) 
//HardwareSerial  		Serial4(RT_HW_UART4_RX,RT_HW_UART4_TX);	//--Объект Serial4 для STM32D
//#endif
//#if defined(RT_HW_PERMIT_UART5) && defined(RT_HW_CORE_STM32_D)	//====== UART5:(num=5) 
//HardwareSerial  		Serial5(RT_HW_UART5_RX,RT_HW_UART5_TX);	//--Объект Serial5 для STM32D
//#endif
//#if defined(RT_HW_PERMIT_UART6) && defined(RT_HW_CORE_STM32_D)	//====== UART6:(num=6) 
//HardwareSerial  		Serial6(RT_HW_UART6_RX,RT_HW_UART6_TX);	//--Объект Serial6 для STM32D
//#endif
#if defined(RT_HW_PERMIT_UART7) && defined(RT_HW_CORE_STM32_D)	//====== UART7:(num=7) 
HardwareSerial  		Serial7(RT_HW_UART7_RX,RT_HW_UART7_TX);	//--Объект Serial7 для STM32D
#endif
#if defined(RT_HW_PERMIT_UART8) && defined(RT_HW_CORE_STM32_D)	//====== UART8:(num=8) 
HardwareSerial  		Serial8(RT_HW_UART3_RX,RT_HW_UART8_TX);	//--Объект Serial8 для STM32D
#endif
#if defined(RT_HW_PERMIT_UARTS)									//====== UARTS:(num=9) 
SoftwareSerial SerialS(RT_HW_UARTS_RX, RT_HW_UARTS_TX); //--Объект UARTS
#endif
#if defined(RT_HW_PERMIT_UARTB)
//-------------------------------------------------------------------------------------------------
//  Здесь объект создавать не рекомендуется. 
//  Если это сделать здесь, то в отличии например от Wire.h, созданный объект сразу будет занимать память(500кб) 
//  не зависимо от фактического использования встроенного  Bluetooth.
//  Хорошим решением является вставка ниже закоментированного кода непосредственно в проект; 
//-------------------------------------------------------------------------------------------------
BluetoothSerial SerialB; 	//--Объект UARTB;
#endif
//=================================================================================================	

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//										API.cpp UART
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 

//=================================================================================================
// 			4.Инициализация uartBegin(n)
//void begin(unsigned long baud, uint32_t config=SERIAL_8N1, int8_t rxPin=-1, int8_t txPin=-1, bool invert=false, unsigned long timeout_ms = 20000UL, uint8_t rxfifo_full_thrhd = 112);
//=================================================================================================	
void     RT_HW_BASE:: uartBegin(uint8_t n){
#if defined(RT_HW_PERMIT_UART0)	
//- - - - - - - - - - - - - - - - - - - - - - - -
#if defined(RT_HW_CORE_ESP32S)
if(n==0){if(uartGetState(n)==0){uartSetState(1,n); Serial.begin(uartGetSpeed(n),uartGetConfig(n),(int8_t)uartGetPinRX(n),(int8_t)uartGetPinTX(n), false, 20000UL, 112); return;}                                                                                  return;}
#endif
//- - - - - - - - - - - - - - - - - - - - - - - -
#if defined(RT_HW_CORE_ESP2C3)
if(n==0){if(uartGetState(n)==0){uartSetState(1,n); Serial.begin(uartGetSpeed(n),uartGetConfig(n),(int8_t)uartGetPinRX(n),(int8_t)uartGetPinTX(n), false, 20000UL, 112); return;}                                                                                  return;}
#endif
#if defined(RT_HW_CORE_ESP32S2) || defined(RT_HW_CORE_ESP32S3)
if(n==0){if(uartGetState(n)==0){uartSetState(1,n); 
//Serial.begin(uartGetSpeed(n),uartGetConfig(n),(int8_t)uartGetPinRX(n),(int8_t)uartGetPinTX(n), false, 20000UL, 112); 
Serial.begin(uartGetSpeed(n));
return;}                                                                                  return;}
#endif
//- - - - - - - - - - - - - - - - - - - - - - - -
if(n==0){if(uartGetState(n)==0){uartSetState(1,n); Serial.begin(uartGetSpeed(n));} return;}
#endif	
#if defined(RT_HW_PERMIT_UART1)
//- - - - - - - - - - - - - - - - - - - - - - - -
#if defined(RT_HW_CORE_ESP32S) || defined(RT_HW_CORE_ESP32S2) || defined(RT_HW_CORE_ESP32S3)
if(n==1){if(uartGetState(n)==0){uartSetState(1,n); Serial1.begin(uartGetSpeed(n),uartGetConfig(n),(int8_t)uartGetPinRX(n),(int8_t)uartGetPinTX(n), false, 20000UL, 112);}  return;}
#endif
//- - - - - - - - - - - - - - - - - - - - - - - -
#if defined(RT_HW_CORE_ESP32C3)
if(n==1){if(uartGetState(n)==0){uartSetState(1,n); Serial1.begin(uartGetSpeed(n),uartGetConfig(n),(int8_t)uartGetPinRX(n),(int8_t)uartGetPinTX(n),false, 20000UL, 112);}  return;}
#endif
//- - - - - - - - - - - - - - - - - - - - - - - -
if(n==1){if(uartGetState(n)==0){uartSetState(1,n); Serial1.begin(uartGetSpeed(n));} return;}
#endif	
#if defined(RT_HW_PERMIT_UART2)
#if defined(RT_HW_CORE_ESP32S) || defined(RT_HW_CORE_ESP32S2) || defined(RT_HW_CORE_ESP32S3)
if(n==2){if(uartGetState(n)==0){uartSetState(1,n); Serial2.begin(uartGetSpeed(n),uartGetConfig(n),(int8_t)uartGetPinRX(n),(int8_t)uartGetPinTX(n), false, 20000UL, 112);}  return;}
#endif
if(n==2){if(uartGetState(n)==0){uartSetState(1,n); Serial2.begin(uartGetSpeed(n));} return;}
#endif	
#if	defined(RT_HW_PERMIT_UART3)
if(n==3){if(uartGetState(n)==0){uartSetState(1,n); Serial3.begin(uartGetSpeed(n));}}
#endif
#if defined(RT_HW_PERMIT_UART4)
if(n==4){if(uartGetState(n)==0){uartSetState(1,n); Serial4.begin(uartGetSpeed(n));}}
#endif	
#if defined(RT_HW_PERMIT_UART5)
if(n==5){if(uartGetState(n)==0){uartSetState(1,n); Serial5.begin(uartGetSpeed(n));}}
#endif
#if defined(RT_HW_PERMIT_UART6)
if(n==6){if(uartGetState(n)==0){uartSetState(1,n); Serial6.begin(uartGetSpeed(n));}}
#endif
#if defined(RT_HW_PERMIT_UART7)
if(n==7){if(uartGetState(n)==0){uartSetState(1,n); Serial7.begin(uartGetSpeed(n));}}
#endif
#if defined(RT_HW_PERMIT_UART8)
if(n==8){if(uartGetState(n)==0){uartSetState(1,n); Serial8.begin(uartGetSpeed(n));}}
#endif
#if defined(RT_HW_PERMIT_UARTS)
if(n==9){if(uartGetState(n)==0){uartSetState(1,n); SerialS.begin(uartGetSpeed(n));}}
#endif
#if defined(RT_HW_PERMIT_UARTB)
if(n==10){if(uartGetState(n)==0){uartSetState(1,n); SerialB.begin(LinkUARTB.name);}}
#endif				
}

//=================================================================================================
// 			5.Проверка подключения устройства (Serial)
//=================================================================================================		
bool     RT_HW_BASE:: uartSerial (uint8_t n){
//--Проверка с учетом особенностей STM32 в среде STM32duino, SEEEDUINO
#if defined(RT_HW_PERMIT_UART0)
if(n==0){
//--------Для программной среды ESP32C3------------------------------------------------------------
#if defined(RT_HW_CORE_ESP32C3)
if(uartUSB.dir==4) {return 1;}
if(uartUSB.dir==0) {uartUSB.timeBegin=millis()+500;	 uartUSB.dir++;  return 0;}
if(uartUSB.dir==1) {if(millis()<(uartUSB.timeBegin))              	{return 0;} 				    
					if(!Serial)									  	{return 0;}	//--Проверка готовности USB;
					uartUSB.timeBegin=millis();
					uartUSB.dir++;									 return 0;} //--Переход на технологическую паузу;
if(uartUSB.dir==2) {if((millis()-uartUSB.timeBegin)<20) 	      	{return 0;} //--Пауза 20мс;
                    bitSet(uart.ready,0);            uartUSB.dir=4;  return 0;} //--Установка флага готовности и переход на завершение;
//				    bitSet(uart.ready,0); 			 uartUSB.dir=4;  return 1;}
#endif
//--------Для программной среды STM32duino---------------------------------------------------------
#if defined(RT_HW_CORE_STM32_D) && defined (USBCON) && defined(USBD_USE_CDC) 
if(uartUSB.dir==4) {return 1;}
if(uartUSB.dir==0) {uartUSB.timeBegin=millis()+500;                		uartUSB.dir++;	return 0;}
if(uartUSB.dir==1) {if(millis()<(uartUSB.timeBegin)){                                 	return 0;} 				    
					if(CDC_connected()){uartUSB.timeBegin=millis()+20;	uartUSB.dir++; 	return 1;}
                    uartUSB.timeBegin=millis()+500;                						return 0;}
if(uartUSB.dir==2) {if(millis()<uartUSB.timeBegin)                 					   {return 0;}
				    bitSet(uart.ready,0); 								uartUSB.dir=4; 	return 1;} 
//--------Для программной среды Seeeduino---------------------------------------------------------
#elif defined(RT_HW_CORE_RP_PICO)
if(uartUSB.dir==4) {												 			 return 1;}	//--Пустой цикл по готовности USB;
if(uartUSB.dir==0) {uartUSB.timeBegin=millis();   	 		uartUSB.dir++; return 0;}	//--Подготовка таймера;
if(uartUSB.dir==1) {if((millis()-uartUSB.timeBegin)<1000) 	      		{return 0;}	//--Пауза 1000мс; 
				    uartUSB.timeBegin=millis();										//--Подготовка таймера;
					if(!Serial)									  				{return 0;}	//--Проверка готовности USB;
					uartUSB.dir++;									 	 return 0;} //--Переход на технологическую паузу;
if(uartUSB.dir==2) {if((millis()-uartUSB.timeBegin)<20) 	      			{return 0;} //--Пауза 20мс;
                    bitSet(uart.ready,0);           	uartUSB.dir=4; return 0;} //--Установка флага готовности и переход на завершение;
//if(uartUSB.dir==2) { {uartUSB.dir=0; return 0;} 
//                    bitSet(uart.ready,0);           uartUSB.dir=4; return 1;} 
//--------Для программной среды Seeeduino---------------------------------------------------------
//#elif defined(RT_HW_CORE_SEEED)
//if(device.uart.dir0==10){return 1;}
//if(device.uart.dir0==0) {             device.uart.timeStart=millis();                                 device.uart.dir0++;  return 0;}
//if(device.uart.dir0==1) {if(getPastMs(device.uart.timeStart)>1500)   {device.uart.timeStart=millis(); device.uart.dir0++;} return 0;}
//if(device.uart.dir0==2) {if(getPastMs(device.uart.timeStart)> 500)                                   {device.uart.dir0++;} return 0;}
//if(device.uart.dir0==3)	{device.uart.timeStart=millis(); 
						  //if(!Serial.dtr()){device.uart.dir0=2;} 						 
//						 if(!Serial){device.uart.dir0=2;} 
//						 else {device.uart.dir0++;} return 0;}
//if(device.uart.dir0==4) {if(getPastMs(device.uart.timeStart) >20) {bitSet(device.uart.ready,0); device.uart.dir0=10;}      return 0;}			 
#else	
//--------Для других программных среды (avr,esp8266,esp32,sam,STM32master_F1,STM32master_F4------	
if(Serial) {bitSet(uart.ready,n); return 1;} else {return 0;}
#endif
//-----------------------------------------------------------------------------------------------
}
#endif
#if defined(RT_HW_PERMIT_UART1)
if(n==1){if(Serial1){bitSet(uart.ready,n); return 1;}}
#endif		
#if defined(RT_HW_PERMIT_UART2)
if(n==2){if(Serial2){bitSet(uart.ready,n); return 1;}}
#endif	
#if defined(RT_HW_PERMIT_UART3)
if(n==3){if(Serial3){bitSet(uart.ready,n); return 1;}}
#endif
#if defined(RT_HW_PERMIT_UART4)
if(n==4){if(Serial4){bitSet(uart.ready,n); return 1;}}
#endif	
#if defined(RT_HW_PERMIT_UART5)
if(n==5){if(Serial5){bitSet(uart.ready,n); return 1;}}
#endif
#if defined(RT_HW_PERMIT_UART6)
if(n==6){if(Serial6){bitSet(uart.ready,n); return 1;}}
#endif
#if defined(RT_HW_PERMIT_UART7)
if(n==7){if(Serial7){bitSet(uart.ready,n); return 1;}}
#endif
#if defined(RT_HW_PERMIT_UART8)
if(n==8){if(Serial8){bitSet(uart.ready,n); return 1;}}
#endif
#if defined(RT_HW_PERMIT_UARTS)
if(n==9){if(SerialS){bitSet(uart.ready,n); return 1;}}
#endif
#if defined(RT_HW_PERMIT_UARTB)
if(n==10){if(SerialB){bitSet(uart.ready,n); return 1;}}
#endif		
return 0;	
};
//=================================================================================================
// 			6.Проверка буферов ввода/вывода
//=================================================================================================
uint16_t RT_HW_BASE:: uartAvailable(uint8_t n){
#if defined(RT_HW_PERMIT_UART0)
if(n==0){return Serial.available();}
#endif	
#if defined(RT_HW_PERMIT_UART1) && !defined(RT_HW_BLOCK_UART1_READ) //---У ESP8266 Serail1 работает только на выход;
if(n==1){return Serial1.available();}
#endif		
#if defined(RT_HW_PERMIT_UART2)
if(n==2){return Serial2.available();}
#endif	
#if defined(RT_HW_PERMIT_UART3)
if(n==3){return Serial3.available();}
#endif
#if defined(RT_HW_PERMIT_UART4)
if(n==4){return Serial4.available();}
#endif	
#if defined(RT_HW_PERMIT_UART5)
if(n==5){return Serial5.available();}
#endif
#if defined(RT_HW_PERMIT_UART6)
if(n==6){return Serial6.available();}
#endif
#if defined(RT_HW_PERMIT_UART7)
if(n==7){return Serial7.available();}
#endif
#if defined(RT_HW_PERMIT_UART8)
if(n==8){return Serial8.available();}
#endif
#if defined(RT_HW_PERMIT_UARTS)
if(n==9){return SerialS.available();}
#endif
#if defined(RT_HW_PERMIT_UARTB)
if(n==10){return SerialB.available();}
#endif		
return 	0;	
};	
uint16_t RT_HW_BASE:: uartAvailableForWrite(uint8_t n){
#if !defined(RT_HW_BLOCK_AVAILABLE_FOR_WRITE) 	//--Не везде присутствует функция Serial.availableForWrite();													
#if defined(RT_HW_PERMIT_UART0)
if(n==0){return Serial.availableForWrite();}
#endif	
#if defined(RT_HW_PERMIT_UART1)
if(n==1){return Serial1.availableForWrite();}
#endif		
#if defined(RT_HW_PERMIT_UART2)
if(n==2){return Serial2.availableForWrite();}
#endif	
#if defined(RT_HW_PERMIT_UART3)
if(n==3){return Serial3.availableForWrite();}
#endif
#if defined(RT_HW_PERMIT_UART4)
if(n==4){return Serial4.availableForWrite();}
#endif	
#if defined(RT_HW_PERMIT_UART5)
if(n==5){return Serial5.availableForWrite();}
#endif
#if defined(RT_HW_PERMIT_UART6)
if(n==6){return Serial6.availableForWrite();}
#endif
#if defined(RT_HW_PERMIT_UART7)
if(n==7){return Serial7.availableForWrite();}
#endif
#if defined(RT_HW_PERMIT_UART8)
if(n==8){return Serial8.availableForWrite();}
#endif
#if defined(RT_HW_PERMIT_UARTS)
//if(n==9){return SerialS.availableForWrite();}
#endif
#if defined(RT_HW_PERMIT_UARTB)
if(n==10){return SerialB.availableForWrite();}
#endif
//---------------------------------------------------------
buff.vu8=n;	//--Для устранения предупреждений от C++;
return 63;	
#endif		//--#if !defined(RT_HW_BLOCK_AVAILABLE_FOR_WRITE) 
buff.vu8=n;	//--Для устранения предупреждений от C++;
return 	63;};
//=================================================================================================
// 			7.Ввод/вывод
//=================================================================================================
uint8_t  RT_HW_BASE:: uartRead(uint8_t n){
#if defined(RT_HW_PERMIT_UART0)
if(n==0){return Serial.read();}
#endif	
#if defined(RT_HW_PERMIT_UART1) && !defined(RT_HW_BLOCK_UART1_READ) //---У ESP8266 Serail1 работает только на выход;
if(n==1){return Serial1.read();}
#endif		
#if defined(RT_HW_PERMIT_UART2) 
if(n==2){return Serial2.read();}
#endif	
#if defined(RT_HW_PERMIT_UART3)
if(n==3){return Serial3.read();}
#endif
#if defined(RT_HW_PERMIT_UART4)
if(n==4){return Serial4.read();}
#endif	
#if defined(RT_HW_PERMIT_UART5)
if(n==5){return Serial5.read();}
#endif
#if defined(RT_HW_PERMIT_UART6)
if(n==6){return Serial6.read();}
#endif
#if defined(RT_HW_PERMIT_UART7)
if(n==7){return Serial7.read();}
#endif
#if defined(RT_HW_PERMIT_UART8)
if(n==8){return Serial8.read();}
#endif
#if defined(RT_HW_PERMIT_UARTS)
if(n==9){return SerialS.read();}
#endif
#if defined(RT_HW_PERMIT_UARTB)
if(n==10){return SerialB.read();}
#endif		
return 	0;	
};
void     RT_HW_BASE:: uartWrite(uint8_t n, uint8_t val){
#if defined(RT_HW_PERMIT_UART0)
if(n==0){
#if defined(RT_HW_CORE_RP_PICO)
	Serial.print(val);
#else
	Serial.write(val);
#endif	
}
#endif	
#if defined(RT_HW_PERMIT_UART1)
if(n==1){Serial1.write(val);}
#endif		
#if defined(RT_HW_PERMIT_UART2)
if(n==2){Serial2.write(val);}
#endif	
#if defined(RT_HW_PERMIT_UART3)
if(n==3){Serial3.write(val);}
#endif
#if defined(RT_HW_PERMIT_UART4)
if(n==4){Serial4.write(val);}
#endif	
#if defined(RT_HW_PERMIT_UART5)
if(n==5){Serial5.write(val);}
#endif
#if defined(RT_HW_PERMIT_UART6)
if(n==6){Serial6.write(val);}
#endif
#if defined(RT_HW_PERMIT_UART7)
if(n==7){Serial7.write(val);}
#endif
#if defined(RT_HW_PERMIT_UART8)
if(n==8){Serial8.write(val);}
#endif
#if defined(RT_HW_PERMIT_UARTS)
if(n==9){SerialS.write(val);}
#endif
#if defined(RT_HW_PERMIT_UARTB)
if(n==10){SerialB.write(val);}
#endif			
};
void     RT_HW_BASE:: uartPrint(uint8_t n, String str){
#if defined(RT_HW_PERMIT_UART0)
if(n==0){Serial.print(str);}
#endif	
#if defined(RT_HW_PERMIT_UART1)
if(n==1){Serial1.print(str);}
#endif		
#if defined(RT_HW_PERMIT_UART2)
if(n==2){Serial2.print(str);}
#endif	
#if defined(RT_HW_PERMIT_UART3)
if(n==3){Serial3.print(str);}
#endif
#if defined(RT_HW_PERMIT_UART4)
if(n==4){Serial4.print(str);}
#endif	
#if defined(RT_HW_PERMIT_UART5)
if(n==5){Serial5.print(str);}
#endif
#if defined(RT_HW_PERMIT_UART6)
if(n==6){Serial6.print(str);}
#endif
#if defined(RT_HW_PERMIT_UART7)
if(n==7){Serial7.print(str);}
#endif
#if defined(RT_HW_PERMIT_UART8)
if(n==8){Serial8.print(str);}
#endif
#if defined(RT_HW_PERMIT_UARTS)
if(n==9){SerialS.print(str);}
#endif
#if defined(RT_HW_PERMIT_UARTB)
if(n==10){SerialB.print(str);}
#endif		
};
//=================================================================================================