//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                                     РАСШИРИТЕЛИ ВВОДА-ВЫВОДА
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//                                      74HC595.SPI
//=================================================================================================
void extSPIhc595  (uint8_t  var){  
if(shSPIhc595.custom==0){RT_HW_Base.setTaskID(shSPIhc595,'Q',25,25,25);}                  //--init:'A'-вывод по измен или периодически; не чаще 50ms; период.(2500ms); тик генератора=25ms;
if(dvSPIhc595.custom==0){dvSPIhc595.setParam(1,RT_HW_Base.device.spi.cs0,0,4000000);}       //--Установка параметров: bitOrder,cs,bus,speed;
   dvSPIhc595.run=RT_HW_Base.directTask(shSPIhc595);         //--Генератор управляющих сигналов [run-0,1,2];
   dvSPIhc595.var=var; dvSPIhc595.direct();
};
void extSPIhc595x2(uint16_t var){  
if(shSPIhc595x2.custom==0){RT_HW_Base.setTaskID(shSPIhc595x2,'Q',25,25,25);}                //--init:'A'-вывод по измен или периодически; не чаще 50ms; период.(2500ms); тик генератора=25ms;
if(dvSPIhc595x2.custom==0){dvSPIhc595x2.setParam(1,RT_HW_Base.device.spi.cs0,0,4000000);}   //--Установка параметров: bitOrder,cs,bus,speed;
   dvSPIhc595x2.run=RT_HW_Base.directTask(shSPIhc595x2);         //--Генератор управляющих сигналов [run-0,1,2];
   dvSPIhc595x2.var=var; dvSPIhc595x2.direct();
};
void extSPIhc595x3(uint32_t var){  
if(shSPIhc595x3.custom==0){RT_HW_Base.setTaskID(shSPIhc595x3,'Q',25,25,25);}                //--init:'A'-вывод по измен или периодически; не чаще 50ms; период.(2500ms); тик генератора=25ms;
if(dvSPIhc595x3.custom==0){dvSPIhc595x3.setParam(1,RT_HW_Base.device.spi.cs0,0,4000000);}   //--Установка параметров: bitOrder,cs,bus,speed;
   dvSPIhc595x3.run=RT_HW_Base.directTask(shSPIhc595x3);         //--Генератор управляющих сигналов [run-0,1,2];
   dvSPIhc595x3.var=var; dvSPIhc595x3.direct();
};
void extSPIhc595x4(uint32_t var){  
if(shSPIhc595x4.custom==0){RT_HW_Base.setTaskID(shSPIhc595x4,'Q',25,25,25);}                //--init:'A'-вывод по измен или периодически; не чаще 50ms; период.(2500ms); тик генератора=25ms;
if(dvSPIhc595x4.custom==0){dvSPIhc595x4.setParam(1,RT_HW_Base.device.spi.cs0,0,4000000);}   //--Установка параметров: bitOrder,cs,bus,speed;
   dvSPIhc595x4.run=RT_HW_Base.directTask(shSPIhc595x4);         //--Генератор управляющих сигналов [run-0,1,2];
   dvSPIhc595x4.var=var; dvSPIhc595x4.direct();
};
//=================================================================================================
//                                      74HC165.SPI
//=================================================================================================
void extSPIhc165(){
if(shSPIhc165.custom==0){RT_HW_Base.setTaskID(shSPIhc165,'P',50,200,50);}                  //--init:'A'-вывод по измен или периодически; не чаще 50ms; период.(2500ms); тик генератора=25ms;
if(dvSPIhc165.custom==0){dvSPIhc165.setParam(0,1,RT_HW_Base.device.spi.cs2,0,4000000);}    //--Установка параметров: inv,bitOrder,cs,bus,speed;
   dvSPIhc165.run=RT_HW_Base.directTask(shSPIhc165);         //--Генератор управляющих сигналов [run-0,1,2];
   dvSPIhc165.direct(); vSPIhc165=dvSPIhc165.var;
   if(dvSPIhc165.fresh){dvSPIhc165.fresh=0; vSPIhc165=dvSPIhc165.var; RT_HW_Base.consoleTest(String(F("HC165")),vSPIhc165);}
};  
//=================================================================================================
//                                      MCP4725.i2c
//=================================================================================================
void extMCP4725(uint16_t var){ 
if(shMCP4725.custom==0){RT_HW_Base.setTaskID(shMCP4725,'A',25,2500,25);}//--init directTask:'A'-вывод по измен.(не чаще 50ms) или период.(2500ms),тик генератора=25ms;
if(dvMCP4725.custom==0){dvMCP4725.setParam(0,0x60,0,0);}                      //--init MCP4725:адрес=0x60;
dvMCP4725.run=RT_HW_Base.directTask(shMCP4725);     //--Генератор управляющих сигналов [run-0,1,2];
dvMCP4725.var=var; dvMCP4725.direct();  //--Управление MCP4725: extDac=выводимое значение,run=разрешение на вывод; shMCP4725.run
};
//=================================================================================================
//                                     Генераторы для теста MCP23017.i2c
//=================================================================================================
void genForTestMCP23017(){
if(idCntA.reset){RT_HW_Base.counterReset  (idCntA,4,0,1,0);}   //--init счетчика:верхняя(Top=8) граница, нижняя граница(Buttom=0),шаг изменения(Step=1); нач.знач.(Begin=0);
if(idCntB.reset){RT_HW_Base.counterReset  (idCntB,8,0,1,0);}   //--init счетчика:верхняя(Top=8) граница, нижняя граница(Buttom=0),шаг изменения(Step=1); нач.знач.(Begin=0);
if(RT_HW_Base.generatorEvent(idGenA,100)){genA=RT_HW_Base.counterS(idCntA); genA=RT_HW_Base.dc8(genA); dvMCP23x17.extA=genA;} 
if(RT_HW_Base.generatorEvent(idGenB,100)){genB=RT_HW_Base.counterT(idCntB); genB=RT_HW_Base.dc8(genB); dvMCP23x17.extB=genB;}  
}
//=================================================================================================
//                                      MCP23017.i2c
//=================================================================================================
void extMCP23017(){ 
if(shMCP23x17in.custom==0) {RT_HW_Base.setTaskID(shMCP23x17in, 'P',50, 100,50);}//--init directTask:'A'-вывод по измен.(не чаще 50ms) или период.(2500ms),тик генератора=25ms;
if(shMCP23x17out.custom==0){RT_HW_Base.setTaskID(shMCP23x17out,'A',50,2500,50);}//--init directTask:'A'-вывод по измен.(не чаще 50ms) или период.(2500ms),тик генератора=25ms;
if(dvMCP23x17.custom==0){dvMCP23x17.cnfgA=0xF0; dvMCP23x17.cnfgIPOLA=0xFF; dvMCP23x17.cnfgGPPUA=0xFF;
                         dvMCP23x17.cnfgB=0x00; dvMCP23x17.cnfgIPOLB=0xFF; dvMCP23x17.cnfgGPPUB=0xFF;
                         dvMCP23x17.adr=0x20;   dvMCP23x17.bus=0; dvMCP23x17.speed=0;
                         dvMCP23x17.custom=1;}  
dvMCP23x17.runIn=RT_HW_Base.directTask(shMCP23x17in);
dvMCP23x17.runOut=RT_HW_Base.directTask(shMCP23x17out);
dvMCP23x17.direct();
};
//=================================================================================================
