//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                                     РАСШИРИТЕЛИ ВВОДА-ВЫВОДА
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//                                      74HC595.SPI
//=================================================================================================
void extSPIhc595  (uint8_t  var){  
if(shSPIhc595.custom==0){RT_HW_Base.setTaskID(shSPIhc595,'Q',25,25,25);}                  //--init:'A'-вывод по измен или периодически; не чаще 50ms; период.(2500ms); тик генератора=25ms;
if(dvSPIhc595.custom==0){dvSPIhc595.setParam(1,RT_HW_Base.device.spi.cs0,0,4000000);}       //--Установка параметров: bitOrder,cs,bus,speed;
   dvSPIhc595.run=RT_HW_Base.directTask(shSPIhc595);         //--Генератор управляющих сигналов [run-0,1,2];
   dvSPIhc595.var=var; dvSPIhc595.direct();
};
//=================================================================================================
//                                      74HC165.SPI
//=================================================================================================
void extSPIhc165(){
if(shSPIhc165.custom==0){RT_HW_Base.setTaskID(shSPIhc165,'P',50,200,50);}                  //--init:'A'-вывод по измен или периодически; не чаще 50ms; период.(2500ms); тик генератора=25ms;
if(dvSPIhc165.custom==0){dvSPIhc165.setParam(0,1,RT_HW_Base.device.spi.cs2,0,4000000);}    //--Установка параметров: inv,bitOrder,cs,bus,speed;
   dvSPIhc165.run=RT_HW_Base.directTask(shSPIhc165);         //--Генератор управляющих сигналов [run-0,1,2];
   dvSPIhc165.direct(); vSPIhc165=dvSPIhc165.var;
   if(dvSPIhc165.fresh){dvSPIhc165.fresh=0; vSPIhc165=dvSPIhc165.var; //RT_HW_Base.consoleTest(String(F("HC165")),vSPIhc165);
   }
};  
//=================================================================================================
//                                      MCP4725.i2c
//=================================================================================================
void extMCP4725(uint16_t var){ 
if(shMCP4725.custom==0){RT_HW_Base.setTaskID(shMCP4725,'A',25,2500,25);}//--init directTask:'A'-вывод по измен.(не чаще 50ms) или период.(2500ms),тик генератора=25ms;
if(dvMCP4725.custom==0){dvMCP4725.setParam(0,0x60,0,0);}                      //--init MCP4725:адрес=0x60;
dvMCP4725.run=RT_HW_Base.directTask(shMCP4725);     //--Генератор управляющих сигналов [run-0,1,2];
dvMCP4725.var=var; dvMCP4725.direct();  //--Управление MCP4725: extDac=выводимое значение,run=разрешение на вывод; shMCP4725.run
};
//=================================================================================================
