//=====================================================================================================
//                              ВЫВОД НА КОНСОЛЬ ЗАГОЛОВКОВ 
//=====================================================================================================
void consoleHead(){
if(RT_HW_Base.console.head){
  RT_HW_Base.consoleHead(String(F("Main parameters")));  RT_HW_Base.consoleBoardGeneral();   
  RT_HW_Base.consoleBoardAdd(); 
  RT_HW_Base.consoleHead(String(F("Available pins")));   RT_HW_Base.consolePinsAll();  
  RT_HW_Base.consoleHead(String(F("Task parameters")));  RT_HW_Base.consoleShedulerParameters();          
  RT_HW_Base.consoleHead(String(F("System pins")));      RT_HW_Base.consolePinsSystem();  
  RT_HW_Base.consoleHead(String(F("Interface")));        RT_HW_Base.consoleInterface(); //--Параметры интерфейсов; 
  RT_HW_Base.consoleHead(String(F("Scan i2c")));         RT_HW_Base.i2cScanBus(0);   
  RT_HW_Base.consoleLine('+');}}
//=====================================================================================================
//                              ОПРОС ADC, ЗАПИСЬ PWM
//=====================================================================================================
void vAnalog(){
vADC= RT_HW_Base.pinAnalogRead (idPinADC,RT_HW_Base.device.pin.adc,'P');              //--Чтение ADC;
vADC= RT_HW_Base.pinAnalogReadDrift(idPinADC,RT_HW_Base.device.pin.adc,vADCdrift);    //--Чтение ADC с фильтрацией дрейфа;
vADCF=filterADC.filtered(vADC);                                                       //--Фильтрация ADC;
vADCPrc=(uint32_t)vADCF*100/4095;                                                     //--Преобразование ФВС 0-4095 в %(0-100);
vPWM= RT_HW_Base.pinAnalogWrite(idPinPWM,RT_HW_Base.device.pin.pwm,1000,vADC);        //--Запись PWM, freq=1000Hz,тип выхода('N','O')-нормальный/открытый выход;
};
//=====================================================================================================
//                              ГЕНЕРАТОРЫ ТЕСТОВЫХ ПЕРЕМЕННЫХ
//=====================================================================================================
void generatorVar(){
//-----------------------------Генератор символов------------------------------------------------------
if(RT_HW_Base.generatorEvent(idGenChar, 1000)){vChar='A'+cntChar; if(++cntChar>5){cntChar=0;}} //--Генератор(1000ms)символов 'A',....;
//-----------------------------Генератор бегущей единицы 1-8, пила 100ms ------------------------------
if(idCntRUN8.reset){RT_HW_Base.counterReset(idCntRUN8,8,0,1,0);}   //--init счетчика:верхняя(Top=8) граница, нижняя граница(Buttom=0),шаг изменения(Step=1); нач.знач.(Begin=0);
if(RT_HW_Base.generatorEvent(idGenRUN8,100)){genRUN8=RT_HW_Base.dc8(RT_HW_Base.counterS(idCntRUN8));}; //--Периодический(100ms) выполнение "Счетчик-Пила";            
//-----------------------------Генератор бегущей единицы 1-16, пила 100ms ------------------------------
if(idCntRUN16.reset){RT_HW_Base.counterReset(idCntRUN16,16,0,1,0);}   //--init счетчика:верхняя(Top=16) граница, нижняя граница(Buttom=0),шаг изменения(Step=1); нач.знач.(Begin=0);
if(RT_HW_Base.generatorEvent(idGenRUN16,50)){genRUN16=RT_HW_Base.dc16(RT_HW_Base.counterS(idCntRUN16));}; //--Периодический(100ms) выполнение "Счетчик-Пила"; 
//-----------------------------Генератор бегущей единицы 1-24, пила 100ms ------------------------------
if(idCntRUN24.reset){RT_HW_Base.counterReset(idCntRUN24,24,0,1,0);}   //--init счетчика:верхняя(Top=24) граница, нижняя граница(Buttom=0),шаг изменения(Step=1); нач.знач.(Begin=0);
if(RT_HW_Base.generatorEvent(idGenRUN24,25)){genRUN24=RT_HW_Base.dc24(RT_HW_Base.counterS(idCntRUN24));}; //--Периодический(100ms) выполнение "Счетчик-Пила"; 
//-----------------------------Генератор бегущей единицы 1-32, пила 100ms ------------------------------
if(idCntRUN32.reset){RT_HW_Base.counterReset(idCntRUN32,32,0,1,0);}   //--init счетчика:верхняя(Top=32) граница, нижняя граница(Buttom=0),шаг изменения(Step=1); нач.знач.(Begin=0);
if(RT_HW_Base.generatorEvent(idGenRUN32,5)){genRUN32=RT_HW_Base.dc32(RT_HW_Base.counterT(idCntRUN32));}; //--Периодический(100ms) выполнение "Счетчик-Пила";  
//-----------------------------Генератор треугольника 0-4095 для DAC,100ms-----------------------------
if(idCntDAC.reset){RT_HW_Base.counterReset(idCntDAC,4095,0,100,0);}  //--init счетчика:верхняя(Top=4095) граница, нижняя граница(Buttom=0),шаг изменения(Step=100); нач.знач.(Begin=0);
if(RT_HW_Base.generatorEvent(idGenDAC,100)) {genDAC=RT_HW_Base.counterT(idCntDAC);}   //--Периодическое(100ms) выполнение "Счетчик-Треугольник";
//-----------------------------------------------------------------------------------------------------
//if(idCntHC595.reset){RT_HW_Base.counterReset(idCntHC595,1,8,1,1);}
//if(RT_HW_Base.generatorEvent(idGenHC595,100)){genHC595=RT_HW_Base.counterS(idCntHC595); genHC595=RT_HW_Base.dc8(genHC595);}
//-----------------------------------------------------------------------------------------------------

};  //++++END GenVar_Button()==========================================================================
void getButton()   { //++++Получение значения с кнопки с защитой от дребезга===========================
vBTN=!RT_HW_Base.pinDigitalRead(idPinBTN,RT_HW_Base.device.pin.button,'U');           //--Чтение кнопки с подтянутым пином к Vcc;
vBTNch=RT_HW_Base.changeProtectPinDI(idChBTN,50,vBTN);                                //--Защита от дребезга кнопки;
};  //++++END GenVar_Button()
//=====================================================================================================
/*
void checkAHTXX(){
if((agoDDR!=dvAHTXX.ddr) || (agoSTEP!=dvAHTXX.step)){
agoDDR =dvAHTXX.ddr;
agoSTEP=dvAHTXX.step; 
RT_HW_Base.consoleTest(String(F(" ddr")),       dvAHTXX.ddr,';');
RT_HW_Base.consoleTest(String(F(" step")),      dvAHTXX.step,';');
RT_HW_Base.consoleTest(String(F(" pointDelay")),dvAHTXX.pointDelay,';');
RT_HW_Base.consoleTest(String(F(" sizeDelay")), dvAHTXX.sizeDelay, ';');
RT_HW_Base.consoleTest(String(F(" workDelay")), dvAHTXX.workDelay, ';');
RT_HW_Base.consoleTest(String(F(" codeErr")),   dvAHTXX.codeErr, ';');
RT_HW_Base.consoleTest(String(F(" T")),         dvAHTXX.vTemp,';');
RT_HW_Base.consoleTest(String(F(" H")),         dvAHTXX.vHum);
}}
*/
/*
void checkMCP4725(){
if((agoDDR!=dvMCP4725.ddr)){
agoRUN=shMCP4725.run; 
agoDDR=dvMCP4725.ddr;
RT_HW_Base.consoleTest(String(F("MCP4725 run")),agoRUN,';');
RT_HW_Base.consoleTest(String(F(" ddr")),agoDDR,';');
RT_HW_Base.consoleTest(String(F(" DAC")),dvMCP4725.vDAC);
}}
*/
/*
void checkMAX6675x(){
if((agoDDR!=dvMAX6675x.ddr) || (agoSTEP!=dvMAX6675x.step)){
agoDDR =dvMAX6675x.ddr;
agoSTEP=dvMAX6675x.step; 
if(dvMAX6675x.custom==1){dvMAX6675x.custom=2;
RT_HW_Base.consoleTest(String(F("***MAX6675x mi")),dvMAX6675x.mi,';');
RT_HW_Base.consoleTest(String(F(" pinSCK")), dvMAX6675x.spn.idSCK.pin,';');
RT_HW_Base.consoleTest(String(F(" pinMISO")),dvMAX6675x.spn.idMISO.pin,';');
RT_HW_Base.consoleTest(String(F(" pinMOSI")),dvMAX6675x.spn.idMOSI.pin,';');
RT_HW_Base.consoleTest(String(F(" pinCS")),  dvMAX6675x.spn.idCS.pin,';');
RT_HW_Base.consoleTest(String(F(" time")), dvMAX6675x.spn.time);
}
RT_HW_Base.consoleTest(String(F("MAX6675x mi")),dvMAX6675x.mi,';');
RT_HW_Base.consoleTest(String(F(" ddr")),dvMAX6675x.ddr,';');
RT_HW_Base.consoleTest(String(F(" step")),      dvMAX6675x.step,';');
RT_HW_Base.consoleTest(String(F(" pointDelay")),dvMAX6675x.pointDelay,';');
RT_HW_Base.consoleTest(String(F(" sizeDelay")), dvMAX6675x.sizeDelay, ';');
RT_HW_Base.consoleTest(String(F(" workDelay")), dvMAX6675x.workDelay, ';');
RT_HW_Base.consoleTest(String(F(" codeErr")),   dvMAX6675x.codeErr, ';');
RT_HW_Base.consoleVar(String(F(" raw")));    RT_HW_Base.consoleVar(dvMAX6675x.rawData,';',0,'H');
RT_HW_Base.consoleTest(String(F(" T")),         dvMAX6675x.vTemp);
}}
*/
