//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                                      ФУНКЦИИ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//                       CMBTHP.i2c (комбинированный сенсор AHTXX(T,H)+BMP280(P)
//  RT_HW_AHTXX   dvCMAHT;   RT_HW_STRUCT_SHED_TASK shCMAHT; float vCMTemp,vCMHum,vCMPress;  uint8_t vCMok; 
//  RT_HW_BME280  dvCMBMP;  RT_HW_STRUCT_SHED_TASK shCMBMP;      
//=================================================================================================
void snsCMTHP(){
if(shedCMBMP.custom==0) {RT_HW_Base.setTaskID(shedCMBMP, 2600); } //--Настройка периодического опроса температуры с периодом 2600ms;
if(devCMBMP.custom==0){devCMBMP.setParam('I',0x77,0,0); devCMBMP.permitHum=0; devCMBMP.permitTemp=0;} //--Настройка параметров сенсора(i2c('I'),adr,busspeed,блокировка Hum,Temp);
//------------------
if(shedCMAHT.custom==0){RT_HW_Base.setTaskID(shedCMAHT,2200);}   //--Настройка периодического опроса с периодом 2200ms;
if(devCMAHT.custom==0){devCMAHT.setParam(0x38,0,0);}          //--Настройка параметров сенсора(адрес,номер шины,скорость);
//-----------------
devCMBMP.runPress=RT_HW_Base.directTask(shedCMBMP);            //--Чтение события запуска измерения давления    от планировщика directTask();   
devCMBMP.direct();   
devCMAHT.run=RT_HW_Base.directTask(shedCMAHT);                 //--Чтение события запуска измерения от планировщика directTask();
devCMAHT.direct();                                           //--Управление сенсором;
//------------------
if(devCMAHT.fresh || devCMBMP.fresh){ 
devCMAHT.fresh=devCMBMP.fresh=0; if(devCMAHT.ok && devCMBMP.ok){vCMTHPok=1;} else{vCMTHPok=0;} 
vCMTemp=devCMAHT.vTemp; vCMHum=devCMAHT.vHum; vCMPress=devCMBMP.vPress;} //--Обновление измеренных данных;
};
//=================================================================================================
//                                     MAX6675.SPI
//=================================================================================================
void sns_spiMAX6675(){
if(spiDevMAX6675.custom==0){RT_HW_max6675.setParamSPI(spiDevMAX6675,spiPinMAX6675cs,0);}  //--Настройка параметров сенсора cs, номер шины;) 
if(spiShedMAX6675.custom==0){RT_HW_Base.setTaskID(spiShedMAX6675,1200);} //--Настройка вызова сенсора (периодический вызов, периодом=1200ms);                        
spiDevMAX6675.run=RT_HW_Base.directTask(spiShedMAX6675);                 //--Чтение события запуска измерения от планировщика directTask()                      
RT_HW_max6675.direct(spiDevMAX6675);                                     //--Вызов функции MAX6675();                                              
if(spiDevMAX6675.fresh){spiDevMAX6675.fresh=0; spiMAX6675temp=spiDevMAX6675.vTemp; spiMAX6675ok=spiDevMAX6675.ok;} //--Ообновление данных;
};
//=================================================================================================
//                                     MAX6675.SPN
//=================================================================================================
void sns_spnMAX6675(){
if(spnDevMAX6675.custom==0) {RT_HW_max6675.setParamSPN(spnDevMAX6675,spnPinMAX6675sck,spnPinMAX6675miso,spnPinMAX6675mosi,spnPinMAX6675cs,0);} //--Настройка: id, 
if(spnShedMAX6675.custom==0){RT_HW_Base.setTaskID(spnShedMAX6675,1200);} //--Настройка периодического вызова с периодом 1200ms;
spnDevMAX6675.run=RT_HW_Base.directTask(spnShedMAX6675);                  //--Чтение события запуска измерения от планировщика directTask()                      
RT_HW_max6675.direct(spnDevMAX6675);                                          
if(spnDevMAX6675.fresh){spnDevMAX6675.fresh=0; spnMAX6675temp=spnDevMAX6675.vTemp; spnMAX6675ok=spnDevMAX6675.ok;} //--Обновление измеренных данных;
};
//=====================================================================================================
