//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//     			 БИБЛИОТЕКА RT_HW_SPI_HC595
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  ecoins (ecoins@mail.ru) 
//  2022-22-18: Begin version
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-------------------------------------------------------------------------------------------------
#ifndef RT_HW_SPI_HC595_h
#define RT_HW_SPI_HC595_h
#define RT_HW_SPI_HC595_VER 10	//--Номер версии библиотеки;
#include "RT_HW_BASE.h"			//--Подключение базовой библиотеки;
//=================================================================================================
class RT_HW_SPIhc595  {		//+++++КЛАСС УПРАВЛЕНИЯ RT_HW_SPIhc595=================================
public:
uint8_t  custom=0, run=0, cmdRun=1, ddr=0, initDevice=0, codeErr; 
uint8_t  bitOrder=1,cs=255; uint8_t bus=0; uint32_t speed=0;
uint8_t  var,ago,bf;
//-------------------------------------------------------------------------------------------------
void setParam(uint8_t _bitOrder, uint8_t _cs, uint8_t _bus=0, uint32_t _speed=0){
bitOrder=_bitOrder; cs=_cs; bus=_bus; speed=_speed; custom=1;
};	//++++Установка параметров;
void direct(){
//-------------------------------------------------------------------------------------------------
if(run==1){              ago=var; cmdRun=1;} 
if(run==2){if(ago!=var) {ago=var; cmdRun=1;}} 
//-------------------------------------------------------------------------------------------------
if(ddr== 0){if(custom!=1){return;} initDevice=0; ddr=10;}	//--Инициализация;
if(ddr==10){if(!cmdRun){return;} cmdRun=0; bf=var;
if(!initDevice){ddr=20;} else{ddr=30;}}	//--Выбор продолжения;
//-------------------------------------------------------------------------------------------------
if(ddr==20){	
if(!RT_HW_Base.SPIinitDevice(codeErr,cs,bus)){return;}  //--Инициализация шины с проверкой CS;
if(codeErr){ddr=10; codeErr=80; return;} else{initDevice=1; ddr=30;}} 
//-------------------------------------------------------------------------------------------------
if(ddr==30){RT_HW_Base.SPIhc595(bitOrder,bf,cs,bus,speed); ddr=10;}}//--Вывод через SPI;
};	//++++END class RT_HW_SPI_HC595================================================================
class RT_HW_SPIhc595x2{		//+++++КЛАСС УПРАВЛЕНИЯ RT_HW_SPIhc595x2===============================
public:
uint8_t  custom=0, run=0, cmdRun=1, ddr=0, initDevice=0, codeErr; 
uint8_t  bitOrder=1,cs=255; uint8_t bus=0; uint32_t speed=0;
uint16_t var,ago,bf;
//-------------------------------------------------------------------------------------------------
void setParam(uint8_t _bitOrder, uint8_t _cs, uint8_t _bus=0, uint32_t _speed=0){
bitOrder=_bitOrder; cs=_cs; bus=_bus; speed=_speed; custom=1;
};	//++++Установка параметров;
void direct(){
//-------------------------------------------------------------------------------------------------
if(run==1){              ago=var; cmdRun=1;} 
if(run==2){if(ago!=var) {ago=var; cmdRun=1;}} 
//-------------------------------------------------------------------------------------------------
if(ddr== 0){if(custom!=1){return;} initDevice=0; ddr=10;}	//--Инициализация;
if(ddr==10){if(!cmdRun){return;} cmdRun=0; bf=var;
if(!initDevice){ddr=20;} else{ddr=30;}}	//--Выбор продолжения;
//-------------------------------------------------------------------------------------------------
if(ddr==20){	
if(!RT_HW_Base.SPIinitDevice(codeErr,cs,bus)){return;}  //--Инициализация шины с проверкой CS;
if(codeErr){ddr=10; codeErr=80; return;} else{initDevice=1; ddr=30;}} 
//-------------------------------------------------------------------------------------------------
if(ddr==30){RT_HW_Base.SPIhc595x2(bitOrder,bf,cs,bus,speed); ddr=10;}}//--Вывод через SPI;
};	//++++END class RT_HW_SPI_HC595================================================================
class RT_HW_SPIhc595x3{		//+++++КЛАСС УПРАВЛЕНИЯ RT_HW_SPIhc595x3===============================
public:
uint8_t  custom=0, run=0, cmdRun=1, ddr=0, initDevice=0, codeErr; 
uint8_t  bitOrder=1,cs=255; uint8_t bus=0; uint32_t speed=0;
uint32_t var,ago,bf;
//-------------------------------------------------------------------------------------------------
void setParam(uint8_t _bitOrder, uint8_t _cs, uint8_t _bus=0, uint32_t _speed=0){
bitOrder=_bitOrder; cs=_cs; bus=_bus; speed=_speed; custom=1;
};	//++++Установка параметров;
void direct(){
//-------------------------------------------------------------------------------------------------
if(run==1){              ago=var; cmdRun=1;} 
if(run==2){if(ago!=var) {ago=var; cmdRun=1;}} 
//-------------------------------------------------------------------------------------------------
if(ddr== 0){if(custom!=1){return;} initDevice=0; ddr=10;}	//--Инициализация;
if(ddr==10){if(!cmdRun){return;} cmdRun=0; bf=var;
if(!initDevice){ddr=20;} else{ddr=30;}}	//--Выбор продолжения;
//-------------------------------------------------------------------------------------------------
if(ddr==20){	
if(!RT_HW_Base.SPIinitDevice(codeErr,cs,bus)){return;}  //--Инициализация шины с проверкой CS;
if(codeErr){ddr=10; codeErr=80; return;} else{initDevice=1; ddr=30;}} 
//-------------------------------------------------------------------------------------------------
if(ddr==30){RT_HW_Base.SPIhc595x3(bitOrder,bf,cs,bus,speed); ddr=10;}}//--Вывод через SPI;
};	//++++END class RT_HW_SPI_HC595================================================================
class RT_HW_SPIhc595x4{		//+++++КЛАСС УПРАВЛЕНИЯ RT_HW_SPIhc595x4===============================
public:
uint8_t  custom=0, run=0, cmdRun=1, ddr=0, initDevice=0, codeErr; 
uint8_t  bitOrder=1,cs=255; uint8_t bus=0; uint32_t speed=0;
uint32_t var,ago,bf;
//-------------------------------------------------------------------------------------------------
void setParam(uint32_t _bitOrder, uint8_t _cs, uint8_t _bus=0, uint32_t _speed=0){
bitOrder=_bitOrder; cs=_cs; bus=_bus; speed=_speed; custom=1;
};	//++++Установка параметров;
void direct(){
//-------------------------------------------------------------------------------------------------
if(run==1){              ago=var; cmdRun=1;} 
if(run==2){if(ago!=var) {ago=var; cmdRun=1;}} 
//-------------------------------------------------------------------------------------------------
if(ddr== 0){if(custom!=1){return;} initDevice=0; ddr=10;}	//--Инициализация;
if(ddr==10){if(!cmdRun){return;} cmdRun=0; bf=var;
if(!initDevice){ddr=20;} else{ddr=30;}}	//--Выбор продолжения;
//-------------------------------------------------------------------------------------------------
if(ddr==20){	
if(!RT_HW_Base.SPIinitDevice(codeErr,cs,bus)){return;}  //--Инициализация шины с проверкой CS;
if(codeErr){ddr=10; codeErr=80; return;} else{initDevice=1; ddr=30;}} 
//-------------------------------------------------------------------------------------------------
if(ddr==30){RT_HW_Base.SPIhc595x4(bitOrder,bf,cs,bus,speed); ddr=10;}}//--Вывод через SPI;
};	//++++END class RT_HW_SPI_HC595x4==============================================================

class RT_HW_SPNhc595  {		//+++++КЛАСС УПРАВЛЕНИЯ RT_HW_SPNhc595=================================
public:
RT_HW_STRUCT_SPN spn;
uint8_t  custom=0, run=0, cmdRun=1, ddr=0, initDevice=0, codeErr; 
uint8_t  bitOrder=1; uint8_t speed=0;
uint8_t  var,ago,bf;
//-------------------------------------------------------------------------------------------------
void setParam(uint8_t bitOrder, uint8_t sck, uint8_t mosi, uint8_t cs, uint8_t speed=0){//++++Установка параметров;
 bitOrder=bitOrder; spn.idSCK.pin=sck; spn.idMISO.pin=255; spn.idMOSI.pin=mosi; spn.idCS.pin=cs; spn.speed=speed; custom=1;};	
void direct(){
//-------------------------------------------------------------------------------------------------
if(run==1){              ago=var; cmdRun=1;} 
if(run==2){if(ago!=var) {ago=var; cmdRun=1;}} 
//-------------------------------------------------------------------------------------------------
if(ddr== 0){if(custom!=1){return;} initDevice=0; ddr=10;}	//--Инициализация;
if(ddr==10){if(!cmdRun){return;} cmdRun=0; bf=var;
if(!initDevice){ddr=20;} else{ddr=30;}}	//--Выбор продолжения;
//-------------------------------------------------------------------------------------------------
if(ddr==20){	
RT_HW_Base.SPNinitDevice(spn,codeErr); //--Инициализация шины с проверкой CS;
if(spn.status==1){initDevice=1; ddr=30;} else{ddr=90;}} 
//-------------------------------------------------------------------------------------------------
//SPNwrite  (RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint8_t  tx
if(ddr==30){RT_HW_Base.SPNwrite(spn,bitOrder,bf); ddr=10;}//--Вывод через SPN;
if(ddr==90){return;}}
};	//++++END class RT_HW_SPN_HC595================================================================
class RT_HW_SPNhc595x2{		//+++++КЛАСС УПРАВЛЕНИЯ RT_HW_SPNhc595x2===============================
public:
RT_HW_STRUCT_SPN spn;
uint8_t  custom=0, run=0, cmdRun=1, ddr=0, initDevice=0, codeErr; 
uint8_t  bitOrder=1; uint8_t speed=0;
uint16_t  var,ago,bf;
//-------------------------------------------------------------------------------------------------
void setParam(uint8_t bitOrder, uint8_t sck, uint8_t mosi, uint8_t cs, uint8_t speed=0){//++++Установка параметров;
 bitOrder=bitOrder; spn.idSCK.pin=sck; spn.idMISO.pin=255; spn.idMOSI.pin=mosi; spn.idCS.pin=cs; spn.speed=speed; custom=1;};	
void direct(){
//-------------------------------------------------------------------------------------------------
if(run==1){              ago=var; cmdRun=1;} 
if(run==2){if(ago!=var) {ago=var; cmdRun=1;}} 
//-------------------------------------------------------------------------------------------------
if(ddr== 0){if(custom!=1){return;} initDevice=0; ddr=10;}	//--Инициализация;
if(ddr==10){if(!cmdRun){return;} cmdRun=0; bf=var;
if(!initDevice){ddr=20;} else{ddr=30;}}	//--Выбор продолжения;
//-------------------------------------------------------------------------------------------------
if(ddr==20){	
RT_HW_Base.SPNinitDevice(spn,codeErr); //--Инициализация шины с проверкой CS;
if(spn.status==1){initDevice=1; ddr=30;} else{ddr=90;}} 
//-------------------------------------------------------------------------------------------------
//SPNwrite  (RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint8_t  tx
if(ddr==30){RT_HW_Base.SPNwrite16(spn,bitOrder,bf); ddr=10;}//--Вывод через SPN;
if(ddr==90){return;}}
};	//++++END class RT_HW_SPN_HC595x2===============================================================
class RT_HW_SPNhc595x3{		//+++++КЛАСС УПРАВЛЕНИЯ RT_HW_SPNhc595x3===============================
public:
RT_HW_STRUCT_SPN spn;
uint8_t  custom=0, run=0, cmdRun=1, ddr=0, initDevice=0, codeErr; 
uint8_t  bitOrder=1; uint8_t speed=0;
uint32_t  var,ago,bf;
//-------------------------------------------------------------------------------------------------
void setParam(uint8_t bitOrder, uint8_t sck, uint8_t mosi, uint8_t cs, uint8_t speed=0){//++++Установка параметров;
 bitOrder=bitOrder; spn.idSCK.pin=sck; spn.idMISO.pin=255; spn.idMOSI.pin=mosi; spn.idCS.pin=cs; spn.speed=speed; custom=1;};	
void direct(){
//-------------------------------------------------------------------------------------------------
if(run==1){              ago=var; cmdRun=1;} 
if(run==2){if(ago!=var) {ago=var; cmdRun=1;}} 
//-------------------------------------------------------------------------------------------------
if(ddr== 0){if(custom!=1){return;} initDevice=0; ddr=10;}	//--Инициализация;
if(ddr==10){if(!cmdRun){return;} cmdRun=0; bf=var;
if(!initDevice){ddr=20;} else{ddr=30;}}	//--Выбор продолжения;
//-------------------------------------------------------------------------------------------------
if(ddr==20){	
RT_HW_Base.SPNinitDevice(spn,codeErr); //--Инициализация шины с проверкой CS;
if(spn.status==1){initDevice=1; ddr=30;} else{ddr=90;}} 
//-------------------------------------------------------------------------------------------------
//SPNwrite  (RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint8_t  tx
if(ddr==30){RT_HW_Base.SPNwrite24(spn,bitOrder,bf); ddr=10;}//--Вывод через SPN;
if(ddr==90){return;}}
};	//++++END class RT_HW_SPN_HC595x3===============================================================
class RT_HW_SPNhc595x4{		//+++++КЛАСС УПРАВЛЕНИЯ RT_HW_SPNhc595x4===============================
public:
RT_HW_STRUCT_SPN spn;
uint8_t  custom=0, run=0, cmdRun=1, ddr=0, initDevice=0, codeErr; 
uint8_t  bitOrder=1; uint8_t speed=0;
uint32_t  var,ago,bf;
//-------------------------------------------------------------------------------------------------
void setParam(uint8_t bitOrder, uint8_t sck, uint8_t mosi, uint8_t cs, uint8_t speed=0){//++++Установка параметров;
 bitOrder=bitOrder; spn.idSCK.pin=sck; spn.idMISO.pin=255; spn.idMOSI.pin=mosi; spn.idCS.pin=cs; spn.speed=speed; custom=1;};	
void direct(){
//-------------------------------------------------------------------------------------------------
if(run==1){              ago=var; cmdRun=1;} 
if(run==2){if(ago!=var) {ago=var; cmdRun=1;}} 
//-------------------------------------------------------------------------------------------------
if(ddr== 0){if(custom!=1){return;} initDevice=0; ddr=10;}	//--Инициализация;
if(ddr==10){if(!cmdRun){return;} cmdRun=0; bf=var;
if(!initDevice){ddr=20;} else{ddr=30;}}	//--Выбор продолжения;
//-------------------------------------------------------------------------------------------------
if(ddr==20){	
RT_HW_Base.SPNinitDevice(spn,codeErr); //--Инициализация шины с проверкой CS;
if(spn.status==1){initDevice=1; ddr=30;} else{ddr=90;}} 
//-------------------------------------------------------------------------------------------------
//SPNwrite  (RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint8_t  tx
if(ddr==30){RT_HW_Base.SPNwrite32(spn,bitOrder,bf); ddr=10;}//--Вывод через SPN;
if(ddr==90){return;}}
};	//++++END class RT_HW_SPN_HC595x4==============================================================
//-------------------------------------------------------------------------------------------------
#endif
//=================================================================================================
