//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                                     БАЗОВЫЕ ФУНКЦИИ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//=================================================================================================
//                              Инициализация параметров
//=================================================================================================
void initProject(){
if(vInit){return;} vInit=1;
pinControl    =RT_HW_Base.device.pin.control;   //--Номер пина Control;
pinLed        =RT_HW_Base.device.pin.led;       //--Номер пина Led;
pinButton     =RT_HW_Base.device.pin.button;    //--Номер пина Кнопки;
pinPWM        =RT_HW_Base.device.pin.pwm;       //--Номер пина PWM;
pinADC        =RT_HW_Base.device.pin.adc;       //--Номер пина ADC;  
};
//=================================================================================================
//                              ВЫВОД НА КОНСОЛЬ ЗАГОЛОВКОВ 
//=================================================================================================
void consoleHead(){
RT_HW_Base.consoleCR(3);
RT_HW_Base.consoleHead(String(F("Main parameters")),'='); RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleBoardGeneral();   
RT_HW_Base.consoleHead(String(F("Add parameters")));      RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleBoardAdd(); 
RT_HW_Base.consoleHead(String(F("Task parameters")));     RT_HW_Base.consoleShedulerParameters();
//RT_HW_Base.consoleHead(String(F("PGM array")));           RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleFromPGM();
//RT_HW_Base.consoleHead(String(F("Available pins")));      RT_HW_Base.mess.modePin='A'; RT_HW_Base.consolePinsAll();        
RT_HW_Base.consoleHead(String(F("Interface")));           RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleInterface(); 
RT_HW_Base.consoleHead(String(F("System & test pins")));  RT_HW_Base.mess.modePin='T'; RT_HW_Base.consolePinsSystem(); RT_HW_Base.consolePinsTest();  
//RT_HW_Base.consoleHead(String(F("Scan i2c")));            RT_HW_Base.mess.modePin='T'; RT_HW_Base.i2cScanBus(0);   
RT_HW_Base.consoleLine('+'); 
}
//=====================================================================================================
//                              ОПРОС ADC, ЗАПИСЬ PWM
//=====================================================================================================
void fncADC(){
if(idPinADC.dir==0){idPinADC.pin=pinADC;}       //--Настройка ADC;
RT_HW_Base.pinAnalogRead(idPinADC);             //--Чтение ADC;
vADCF=filterADC.filtered(idPinADC.vNorm);       //--Фильтрация ADC;
vADCPrc=(uint32_t)vADCF*100/4095;               //--Преобразование ADC с фильтром 0-4095 в %(0-100);
};
//=====================================================================================================
//                              ЗАПИСЬ PWM
//=====================================================================================================
void fncPWM(){
if(idPinPWM.dir==0){idPinPWM.pin=pinPWM; idPinPWM.channel=0; idPinPWM.freq=1000; idPinPWM.depth=16;} //--Настройка PWM, freq=1000Hz,тип выхода('N','O')-нормальный; разрядность 16;
RT_HW_Base.pinPWM(idPinPWM,vADCF);  vPWM=idPinPWM.var;                                               //--Запись PWM;
};
//=====================================================================================================
