//============================Объекты и переменные Lcd.1================================
RT_HW_LCD44780_DEVICE_ID z1; uint8_t n1; 
RT_HW_LCD44780_PARAM_ID  z1Blink, z1BTN, z1SnsOk, z1speed;
RT_HW_LCD44780_PARAM_ID  z1DsOk,  z1DsTemp; const char z1hDs[]    PROGMEM="DT="; 
RT_HW_LCD44780_PARAM_ID  z1ADC,   z1PWM;    const char z1hADC[]   PROGMEM="A=";  const char z1hPWM[] PROGMEM="P=";
RT_HW_LCD44780_PARAM_ID  z1Temp,  z1Hum;    const char z1hTemp[]  PROGMEM="T=";  const char z1hHum[] PROGMEM="H=";
RT_HW_LCD44780_PARAM_ID  z1Pulse;           const char z1hPulse[] PROGMEM="I=";  
RT_HW_LCD44780_PARAM_ID  z1HsrOk, z1HsrLen; const char z1hHsr[]   PROGMEM="L=";
//======================================================================================
void Lcd1(){
//--------------------------------------------------------------------------------------
if(z1.custom==0){RT_HW_lcd44780.initDeviceI2CPCF8574(z1,16,2,39,0,400000UL);} RT_HW_lcd44780.directDevice(z1); n1=z1.num;
//--------------------------------------------------------------------------------------
if(z1Blink.custom==0) {RT_HW_lcd44780.initBlinkID (z1Blink,n1,500, 1,1);}            RT_HW_lcd44780.LcdBlink(z1Blink,' ','*');            //--Мерцающий символ;
if(z1BTN.custom==0)   {RT_HW_lcd44780.initBitID   (z1BTN,  n1, 2,1);}                RT_HW_lcd44780.LcdBit  (z1BTN,vChatBut,'-','+');     //--Вывод кнопки;
if(z1ADC.custom==0)   {RT_HW_lcd44780.initWordID  (z1ADC,  n1,'U','L',';', 3,1,4);}  RT_HW_lcd44780.LcdVAR  (z1ADC,vADCF);                //--Вывод ADC(без заголовка);
if(z1Pulse.custom==0) {RT_HW_lcd44780.initWordID  (z1Pulse,n1,'U','L',';', 8,1,6);}  RT_HW_lcd44780.LcdVAR  (z1Pulse,idPinServo.duration);//--Вывод PWM(без заголовка);
if(z1speed.custom==0) {RT_HW_lcd44780.initWordID  (z1speed,n1,'U','R','~',14,1,0);}  RT_HW_lcd44780.LcdVAR  (z1speed,vSpeedSmall);        //--Вывод скорости(без заголовка);
//--------------------------------------------------------------------------------------
if(z1DsOk.custom==0)  {RT_HW_lcd44780.initBitID   (z1DsOk,  n1, 1,2);}               RT_HW_lcd44780.LcdBit  (z1DsOk,         vDS1820ok);  //--Вывод vDS1820ok;
if(z1DsTemp.custom==0){RT_HW_lcd44780.initFloatID (z1DsTemp,n1,'2','L',';', 2,2,9);} RT_HW_lcd44780.LcdFloat(z1DsTemp, z1hDs,vDS1820Temp);//--Вывод vDS1820Temp;
if(z1HsrOk.custom==0)  {RT_HW_lcd44780.initBitID  (z1HsrOk, n1,11,2);}               RT_HW_lcd44780.LcdBit  (z1HsrOk,        vSR04ok);    //--Вывод HC-SR04.ok;
if(z1HsrLen.custom==0) {RT_HW_lcd44780.initWordID (z1HsrLen,n1,'U','L',';',12,2,0);} RT_HW_lcd44780.LcdVar  (z1HsrLen,z1hHsr,vSR04Len);   //--Вывод HC-SR04.Len;
//--------------------------------------------------------------------------------------
};
