//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						3.Коды идентификаторов архитектур контроллеров
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
enum {RT_HW_CODE_ARCH_ANON=0,	
      RT_HW_CODE_ARCH_AVR,			RT_HW_CODE_ARCH_SAM,		
	  RT_HW_CODE_ARCH_ESP8266,		RT_HW_CODE_ARCH_ESP32, 		RT_HW_CODE_ARCH_ESP32_C3, 						
	  RT_HW_CODE_ARCH_STM32, 	 	RT_HW_CODE_ARCH_STM32F1,	RT_HW_CODE_ARCH_STM32F4,		
	  RT_HW_CODE_ARCH_STM32H7,
	  RT_HW_CODE_ARCH_SEEED,		RT_HW_CODE_ARCH_RP_PICO};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						3.Коды идентификаторов кодов програмной среды
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
enum {RT_HW_CODE_CORE_ANON=0,	
      RT_HW_CODE_CORE_AVR,			RT_HW_CODE_CORE_SAM, 				
	  RT_HW_CODE_CORE_ESP8266,		RT_HW_CODE_CORE_ESP32, 		RT_HW_CODE_CORE_ESP32_C3, 
	  RT_HW_CODE_CORE_STM32_M_F1, 	RT_HW_CODE_CORE_STM32_M_F4, RT_HW_CODE_CORE_STM32_D,	
	  RT_HW_CODE_CORE_STM32H7,
	  RT_HW_CODE_CORE_SEEED,		RT_HW_CODE_CORE_RP_PICO};    
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								4.Коды типов контроллеров
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	  
enum {RT_HW_CODE_BOARD_ANON=0};
enum {RT_HW_CODE_BOARD_AVR_UNO=1,       	  	RT_HW_CODE_BOARD_AVR_NANO,					RT_HW_CODE_BOARD_AVR_PRO,					
	  RT_HW_CODE_BOARD_AVR_MEGA2560,			RT_HW_CODE_BOARD_AVR_UNKNOW};	  
enum {RT_HW_CODE_BOARD_SAM_DUE=8};
enum {RT_HW_CODE_BOARD_ESP8266_GENERIC=10, 	  	RT_HW_CODE_BOARD_ESP8266_WEMOS_D1MINILITE,	RT_HW_CODE_BOARD_ESP8266_WEMOS_D1MINIPRO, 
      RT_HW_CODE_BOARD_ESP8266_NODEMCU_ESP12, 	RT_HW_CODE_BOARD_ESP8266_NODEMCU_ESP12E,    RT_HW_CODE_BOARD_ESP8266_UNKNOW};
enum {RT_HW_CODE_BOARD_ESP32_DEV=20,       		RT_HW_CODE_BOARD_TTGO_T1,  					RT_HW_CODE_BOARD_LOLIN_D32, 				
      RT_HW_CODE_BOARD_M5Stack_Core_ESP32,	    RT_HW_CODE_BOARD_M5Stack_ATOM,
	  RT_HW_CODE_BOARD_D1_MINI32,               RT_HW_CODE_BOARD_ESP32_UNKNOW};
enum {RT_HW_CODE_BOARD_ESP32_C3_DEV=30, 		RT_HW_CODE_BOARD_ESP32_C3_UNKNOW};	
enum {RT_HW_CODE_BOARD_GENERIC_STM32F103C=40,   RT_HW_CODE_BOARD_GENERIC_STM32F103R, 	    RT_HW_CODE_BOARD_GENERIC_STM32F103V};
enum {RT_HW_CODE_BOARD_GENERIC_STM32F407V=50,   
      RT_HW_CODE_BOARD_STM32F401_BLACKPILL,    	RT_HW_CODE_BOARD_STM32F411_BLACKPILL};
enum {RT_HW_CODE_BOARD_GENERIC_STM32H743VITX=60};	
enum {RT_HW_CODE_BOARD_SEEED_XIAO_M0=70, 		RT_HW_CODE_BOARD_SEEED_ZERO};
enum {RT_HW_CODE_BOARD_NANO_RP2040_CONNECT=80, 	RT_HW_CODE_BOARD_NANO_33_BLE};					
enum {RT_HW_CODE_BOARD_RP_PICO=91};	  
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							6.Индексы массивов хранящихся в PGM
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
enum{RT_HW_PGM_SYS_PAR_ID,  RT_HW_PGM_SYS_ADC_ID,	RT_HW_PGM_SYS_TCH_ID,	RT_HW_PGM_SYS_PWM_ID, RT_HW_PGM_SYS_DAC_ID,  
     RT_HW_PGM_PIN_BRD_ID,   
	 RT_HW_PGM_PIN_I2C_ID,  RT_HW_PGM_PIN_ICS_ID,	RT_HW_PGM_PIN_SPI_ID, 	RT_HW_PGM_PIN_SPN_ID,
	 RT_HW_PGM_PIN_UHS_ID,	RT_HW_PGM_PIN_USS_ID,
	 RT_HW_PGM_PIN_CAN_ID,	RT_HW_PGM_PIN_BTH_ID,	RT_HW_PGM_PIN_ETH_ID,	RT_HW_PGM_PIN_WFI_ID,
//-------------------------------------------------------------------------------------------------
     RT_HW_PGM_PIN_ALL_ID,	RT_HW_PGM_PIN_DIN_ID,	RT_HW_PGM_PIN_ADC_ID,	RT_HW_PGM_PIN_TCH_ID,
	 RT_HW_PGM_PIN_DOT_ID,	RT_HW_PGM_PIN_PWM_ID,	RT_HW_PGM_PIN_DAC_ID,	RT_HW_PGM_PIN_INT_ID, 
	 RT_HW_PGM_PIN_N5V_ID,
//-------------------------------------------------------------------------------------------------
	 RT_HW_PGM_PIN_DBG_ID,	RT_HW_PGM_PIN_OUT_ID,	RT_HW_PGM_PIN_INP_ID, 
	 RT_HW_PGM_PIN_DCT_ID,	RT_HW_PGM_PIN_DEV_ID,	RT_HW_PGM_PIN_CSS_ID,	
	 RT_HW_PGM_PIN_LC6_ID,	RT_HW_PGM_PIN_TFT_ID,	RT_HW_PGM_PIN_URT_ID,  
//-------------------------------------------------------------------------------------------------
	 RT_HW_PGM_ADR_I2C_ID,
//-------------------------------------------------------------------------------------------------	 
	 RT_HW_PGM_QNT_ID,		RT_HW_PGM_END=255}; 	 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							7.Идентификаторы скоростей UART (аппаратный и программный);
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
enum  {RT_HW_UART_SPEED_HS=115200UL, RT_HW_UART_SPEED_SS=9600UL};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							8.Параметры для работы с шиной i2c 
//	1. Коды скоростей шины i2c;
//  2. Скорости(кГц) шины i2c(соответствуют кодам скоростей); block,
//  3. Биты слова состояния: 
//     INIT  -шина инициализирована,                 BUSY  -флаг занятости шины; 
//     MASTER-инициализирована как MASTER;           SLAVE -инициализирована как SLAVE;
//     MODE  -HardWare/SoftWare; 		 			 BLOCK -блокировка изменения пинов; 
//     FREE1 -свободный бит;			             FREE2 -свободный бит;	          
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
enum {RT_HW_I2C_MODE_LOW=0,     RT_HW_I2C_MODE_ST,          RT_HW_I2C_MODE_FM, 
      RT_HW_I2C_MODE_FM1,       RT_HW_I2C_MODE_FM2,         RT_HW_I2C_MODE_FMP,       
	  RT_HW_I2C_MODE_HS,        RT_HW_I2C_MODE_UFM}; 	
enum {RT_HW_I2C_SPEED_LOW=  50, RT_HW_I2C_SPEED_ST = 100,   RT_HW_I2C_SPEED_FM = 400, 
      RT_HW_I2C_SPEED_FM1= 600, RT_HW_I2C_SPEED_FM2= 800,   RT_HW_I2C_SPEED_FMP=1000, 
	  RT_HW_I2C_SPEED_HS =3400, RT_HW_I2C_SPEED_UFM=5000,   RT_HW_I2C_FIND_PERIOD=50};
enum {RT_HW_I2C_STATE_INIT=0,     RT_HW_I2C_STATE_MASTER, 	RT_HW_I2C_STATE_SLAVE,  RT_HW_I2C_STATE_SOFT,       
      RT_HW_I2C_STATE_BLOCK_PINS, RT_HW_I2C_STATE_FREE1,    RT_HW_I2C_STATE_FREE2,	RT_HW_I2C_STATE_FREE3};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							9.Параметры для работы с шиной SPI 
//  1. Скорости шины i2c(соответствуют кодам скоростей); 
//  2. Биты слова состояния: 
//     INIT  -шина инициализирована,                 BUSY  -флаг занятости шины; 
//     MASTER-инициализирована как MASTER;           SLAVE -инициализирована как SLAVE;
//     MODE  -HardWare/SoftWare; 		 			 BLOCK -блокировка изменения пинов;  
//     INPUT -разрешен режим ввода			         OUTPUT-разрешен режим вывода;         
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
enum {RT_HW_SPI_SPEED_LOW=1000,    RT_HW_SPI_SPEED_ST=4000,	RT_HW_SPI_SPEED_FM=16000}; 
enum {RT_HW_SPI_STATE_INIT=0,  	   RT_HW_SPI_STATE_MASTER, 	RT_HW_SPI_STATE_SLAVE,	RT_HW_SPI_STATE_SOFT,      
      RT_HW_SPI_STATE_CHANGE_PINS, RT_HW_SPI_STATE_SCK, 	RT_HW_SPI_STATE_MISO, 	RT_HW_SPI_STATE_MOSI};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++