//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								1.Контроллеры программной среды AVR
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if !defined(RT_HW_BOARD_CODE) 		&& defined(ARDUINO_AVR_UNO)					//====КОНТРОЛЛЕР Arduino Uno;	
#define      RT_HW_BOARD_CODE         RT_HW_CODE_BOARD_AVR_UNO				//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                      "Arduno Uno"				//--Наименование платы;
#define      RT_HW_BOARD_AVR_UNO											//--Идентификатор типа платы [variant.standart]
#define      RT_HW_CORE_AVR													//--Идентификатор программной среды
#endif
//---------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE)     	&& defined(ARDUINO_AVR_NANO) 				//====КОНТРОЛЛЕР Arduino Nano;	
#define      RT_HW_BOARD_CODE         RT_HW_CODE_BOARD_AVR_NANO			    //--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                     "Arduino Nano"     		//--Наименование платы;
#define      RT_HW_BOARD_AVR_NANO											//--Идентификатор типа платы [variant.eigthanaloginputs]
#define      RT_HW_CORE_AVR													//--Идентификатор программной среды
#endif
//---------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE)  	&& defined(ARDUINO_AVR_PRO) 				//====КОНТРОЛЛЕР Arduino Pro or Pro Mini;	
#define      RT_HW_BOARD_CODE         RT_HW_CODE_BOARD_AVR_PRO				//--Идентификатор типа выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME         "Arduino Pro or Pro mini"     		//--Наименование платы;
#define      RT_HW_BOARD_AVR_PRO											//--Идентификатор типа платы [variant.eigthanaloginputs]
#define      RT_HW_CORE_AVR													//--Идентификатор программной среды
#endif
//---------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) 		&& defined(ARDUINO_AVR_MEGA2560) 			//====КОНТРОЛЛЕР Arduino Mega 2560;
#define      RT_HW_BOARD_CODE         RT_HW_CODE_BOARD_AVR_MEGA2560 		//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                    "Arduino Mega 2560"     	//--Наименование платы;
#define      RT_HW_BOARD_AVR_MEGA2560										//--Идентификатор типа платы [variant.mega]
#define      RT_HW_CORE_AVR													//--Идентификатор программной среды
#if defined(RT_HW_BOARD_Arduino_Mega2560)									//--Корректировка 
  #ifdef  PROGMEM															//		для Arduino Mega2560;	
  #undef  PROGMEM															//			атрибута
  #endif																	//				для работы
#define PROGMEM __attribute__(( section(".progmem.data") ))					// 					с PROGMEM для RAM>64kB;
#endif
#endif
//------Идентификация к группе неопознанных контроллеров AVR----------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(__AVR__)
#define      RT_HW_BOARD_CODE         RT_HW_CODE_BOARD_AVR_UNKNOW			//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME         "Unknow board [near Arduno Uno]"		//--Наименование платы;
#define      RT_HW_BOARD_AVR_UNKNOW											//--Идентификатор типа платы [variant.standart]
#define      RT_HW_CORE_AVR													//--Идентификатор программной среды
#endif
//=================================================================================================