
//#define      RT_HW_CORE_PI_PICO_2											//--Идентификатор программной среды
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								9.Контроллеры программной среды RASPBERRIY PI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_RASPBERRY_PI_PICO)		//====КОНТРОЛЛЕР Raspberry Pi Pico;	 
#define      RT_HW_BOARD_CODE      (uint8_t)130        						//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                    "Raspberry Pi Pico"     	//--Наименование платы;
#define      RT_HW_BOARD_RP_PICO											//--Идентификатор типа платы;
#define      RT_HW_CORE_RP_PICO												//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_ADAFRUIT_KB2040_RP2040)   //====КОНТРОЛЛЕР Adafruit KB2040(подмена для RP2040 ZERO);	 
#define      RT_HW_BOARD_CODE      (uint8_t)131                       	    //--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                    "Adafruit KB2040"          //--Наименование платы;
#define      RT_HW_BOARD_RP_PICO_ZERO										//--Идентификатор типа платы;
#define      RT_HW_CORE_RP_PICO												//--Идентификатор программной среды
#endif
//-------------------------------------------------------------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_RASPBERRY_PI_PICO_W)      //====КОНТРОЛЛЕР Raspberry Pi Pico W;	 
#define      RT_HW_BOARD_CODE      (uint8_t)132                      	    //--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                    "Raspberry Pi Pico W"      //--Наименование платы;
#define      RT_HW_BOARD_RP_PICO_W										    //--Идентификатор типа платы;
#define      RT_HW_CORE_RP_PICO											//--Идентификатор программной среды
#endif
//------Идентификация к группе контроллеров RASPBERRY PI-------------------------------------------
#if !defined(RT_HW_BOARD_CODE) && defined(ARDUINO_ARCH_RASPBERRY_PI) 		//--Не опознанный контроллер RP2040;
#define      RT_HW_BOARD_CODE      (uint8_t)139                       		//--Идентификатор выбора платы c кодом платы;
#define      RT_HW_BOARD_NAME                    "Raspberry Pi Pico ANON"   //--Наименование платы;
#define      RT_HW_BOARD_RP_PICO_ANON										//--Идентификатор типа платы ;
#define      RT_HW_CORE_RP_PICO												//--Идентификатор программной среды
#endif
//=================================================================================================