//=================================================================================================
//			ФУНКЦИИ ДЛЯ РАБОТЫ МАССИВАМИ PGM БИБЛИОТЕКИ RT_HW_BASE.h(kind - тип массива)
//=================================================================================================	
String getNameKindPin(uint8_t kind){										//==Возвращает обозначения массива в текстовой форме;
//-------------------------------------------------------------------------------------------------
if(kind==RT_HW_PGM_SYS_PAR_ID) {return String(F("par"));}	
if(kind==RT_HW_PGM_SYS_ADC_ID) {return String(F("adc"));}
if(kind==RT_HW_PGM_SYS_TCH_ID) {return String(F("tch"));}	
if(kind==RT_HW_PGM_SYS_PWM_ID) {return String(F("pwm"));}
if(kind==RT_HW_PGM_SYS_DAC_ID) {return String(F("dac"));}
//-------------------------------------------------------------------------------------------------
if(kind==RT_HW_PGM_PIN_BRD_ID) {return String(F("BRD"));}
if(kind==RT_HW_PGM_PIN_I2C_ID) {return String(F("I2C"));}
if(kind==RT_HW_PGM_PIN_ICS_ID) {return String(F("ICS"));}
if(kind==RT_HW_PGM_PIN_SPI_ID) {return String(F("SPI"));}
if(kind==RT_HW_PGM_PIN_SPN_ID) {return String(F("SPN"));}
if(kind==RT_HW_PGM_PIN_UHS_ID) {return String(F("UHS"));}	
if(kind==RT_HW_PGM_PIN_USS_ID) {return String(F("USS"));}	
if(kind==RT_HW_PGM_PIN_CAN_ID) {return String(F("CAN"));}
if(kind==RT_HW_PGM_PIN_BTH_ID) {return String(F("BTH"));}
if(kind==RT_HW_PGM_PIN_ETH_ID) {return String(F("ETH"));}
if(kind==RT_HW_PGM_PIN_WFI_ID) {return String(F("WFI"));}
//-------------------------------------------------------------------------------------------------
if(kind==RT_HW_PGM_PIN_ALL_ID) {return String(F("ALL"));}	
if(kind==RT_HW_PGM_PIN_DIN_ID) {return String(F("DIN"));}
if(kind==RT_HW_PGM_PIN_ADC_ID) {return String(F("ADC"));}
if(kind==RT_HW_PGM_PIN_TCH_ID) {return String(F("TCH"));}	
if(kind==RT_HW_PGM_PIN_DOT_ID) {return String(F("DOT"));}
if(kind==RT_HW_PGM_PIN_PWM_ID) {return String(F("PWM"));}
if(kind==RT_HW_PGM_PIN_DAC_ID) {return String(F("DAC"));}
if(kind==RT_HW_PGM_PIN_INT_ID) {return String(F("INT"));} 
if(kind==RT_HW_PGM_PIN_N5V_ID) {return String(F("N5V"));}
//-------------------------------------------------------------------------------------------------
if(kind==RT_HW_PGM_PIN_DBG_ID) {return String(F("DBG"));}
if(kind==RT_HW_PGM_PIN_OUT_ID) {return String(F("OUT"));}
if(kind==RT_HW_PGM_PIN_INP_ID) {return String(F("INP"));} 
if(kind==RT_HW_PGM_PIN_DCT_ID) {return String(F("DCT"));}
if(kind==RT_HW_PGM_PIN_DEV_ID) {return String(F("DEV"));}
if(kind==RT_HW_PGM_PIN_CSS_ID) {return String(F("CSS"));}	
if(kind==RT_HW_PGM_PIN_LC6_ID) {return String(F("LC6"));}
if(kind==RT_HW_PGM_PIN_TFT_ID) {return String(F("TFT"));}		
if(kind==RT_HW_PGM_PIN_URT_ID) {return String(F("URT"));}
//-------------------------------------------------------------------------------------------------
if(kind==RT_HW_PGM_ADR_I2C_ID) {return String(F("ADR"));}
//-------------------------------------------------------------------------------------------------	
return String(F(" - "));  };
//-------------------------------------------------------------------------------------------------
//								Чтение элемента из массива //==Возвращает из массива элемент с индексом;
//-------------------------------------------------------------------------------------------------
uint8_t  getFromArrPGM (uint8_t kind, uint8_t n){
	
//-----Системные параметры-------------------------------------------------------------------------
if(kind==RT_HW_PGM_SYS_PAR_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_SYS_PAR,n);}
if(kind==RT_HW_PGM_SYS_ADC_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_SYS_ADC,n);}
if(kind==RT_HW_PGM_SYS_TCH_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_SYS_TCH,n);}
if(kind==RT_HW_PGM_SYS_PWM_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_SYS_PWM,n);}
if(kind==RT_HW_PGM_SYS_DAC_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_SYS_DAC,n);}
//-----Системные пины------------------------------------------------------------------------------
if(kind==RT_HW_PGM_PIN_BRD_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_BRD,n);}
if(kind==RT_HW_PGM_PIN_I2C_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_I2C,n);}
if(kind==RT_HW_PGM_PIN_ICS_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_ICS,n);}
if(kind==RT_HW_PGM_PIN_SPI_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_SPI,n);}
if(kind==RT_HW_PGM_PIN_SPN_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_SPN,n);}
if(kind==RT_HW_PGM_PIN_UHS_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_UHS,n);}
if(kind==RT_HW_PGM_PIN_USS_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_USS,n);}
if(kind==RT_HW_PGM_PIN_CAN_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_CAN,n);}
if(kind==RT_HW_PGM_PIN_BTH_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_BTH,n);}
if(kind==RT_HW_PGM_PIN_ETH_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_ETH,n);}
if(kind==RT_HW_PGM_PIN_WFI_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_WFI,n);}
//-----Пины контроллера----------------------------------------------------------------------------
if(kind==RT_HW_PGM_PIN_ALL_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_ALL,n);}
if(kind==RT_HW_PGM_PIN_DIN_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_DIN,n);}
if(kind==RT_HW_PGM_PIN_ADC_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_ADC,n);}
if(kind==RT_HW_PGM_PIN_TCH_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_TCH,n);}
if(kind==RT_HW_PGM_PIN_DOT_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_DOT,n);}
if(kind==RT_HW_PGM_PIN_PWM_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_PWM,n);}
if(kind==RT_HW_PGM_PIN_DAC_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_DAC,n);}
if(kind==RT_HW_PGM_PIN_INT_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_INT,n);}
if(kind==RT_HW_PGM_PIN_N5V_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_N5V,n);}
//-----Тестовые пины-------------------------------------------------------------------------------
if(kind==RT_HW_PGM_PIN_DBG_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_DBG,n);}
if(kind==RT_HW_PGM_PIN_OUT_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_OUT,n);}
if(kind==RT_HW_PGM_PIN_INP_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_INP,n);}
if(kind==RT_HW_PGM_PIN_DCT_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_DCT,n);}
if(kind==RT_HW_PGM_PIN_DEV_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_DEV,n);}
if(kind==RT_HW_PGM_PIN_CSS_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_CSS,n);}
if(kind==RT_HW_PGM_PIN_LC6_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_LC6,n);}
if(kind==RT_HW_PGM_PIN_TFT_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_TFT,n);}
if(kind==RT_HW_PGM_PIN_URT_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_PIN_URT,n);}
//-----Тестовые адреса устройств i2c---------------------------------------------------------------
if(kind==RT_HW_PGM_ADR_I2C_ID)	{return RT_HW_READ_BYTE_PGM(RT_HW_PGM_ADR_I2C,n);}
//-------------------------------------------------------------------------------------------------
return 0;}	
//-------------------------------------------------------------------------------------------------
//								Чтение элемента из массива с контролем размера массива.
//  Если элемент не найден, возвращаетс 255.
//-------------------------------------------------------------------------------------------------
uint8_t readArrPGM(uint8_t kind, uint8_t n){
uint8_t len=0;
for(uint8_t i=0; i<254; i++){if(getFromArrPGM(kind,i)==RT_HW_PGM_END){break;} len++;} ;
if(n>=len) {return 255;} 
return getFromArrPGM(kind,n);};
//-------------------------------------------------------------------------------------------------
//						Проверяет наличие в массиве пина равным n
//-------------------------------------------------------------------------------------------------
bool checkPinPGM(uint8_t kind, uint8_t n){
for(uint8_t i=0;i<254;i++){uint8_t k=getFromArrPGM(kind,i); if(k==RT_HW_PGM_END) {return  0;} if(k==n){return 1;}} return 0;};
//-------------------------------------------------------------------------------------------------
//							Возвращает размер массива
//-------------------------------------------------------------------------------------------------
uint8_t getLenFullPGM (uint8_t kind){uint8_t cnt=0;
for(uint8_t i=0;i<254;i++){uint8_t k=getFromArrPGM(kind,i); if(k==RT_HW_PGM_END){break;}                  cnt++;} return cnt;};
//-------------------------------------------------------------------------------------------------
//						Проверяет кол-во действительных (<254) значений в массиве
//-------------------------------------------------------------------------------------------------
uint8_t getLenPosPGM  (uint8_t kind){uint8_t cnt=0;	
for(uint8_t i=0;i<254;i++){uint8_t k=getFromArrPGM(kind,i); if(k==RT_HW_PGM_END){break;}     if(k!=255) {cnt++;}} return cnt;};	
//==================================================================================================