//=================================================================================================
//							String: Базовые функции
//=================================================================================================
uint8_t getLenBegin(uint8_t len,uint8_t sz,char alig){	//==Получение Begin-заполнителей(alig=L,C,R,N, len=длина строки, sz=длина заполняемого поля)
if(len<=sz)  {return 0;} 
if(alig=='C'){return (len-sz-(len-sz)/2);}
if(alig=='R'){return (len-sz);}	return 0;};  
uint8_t getLenEnd  (uint8_t len,uint8_t sz,char alig){	//==Получение End-заполнителей(alig=L,C,R,N, len=длина строки, sz=длина заполняемого поля)	
if(len<=sz)  {return 0;}
if(alig=='C'){return (len-sz-getLenBegin(len,sz,alig));}
if(alig=='L'){return (len-sz);}               return 0;}
uint8_t getLenSTR  (String &str,uint8_t lenMax){	 	//==Получение Len текста из String в формате utf-8 с учетом блокирующего символа '~' 							
uint8_t buff,j,len; if(lenMax==0) {lenMax=80;} j=len=0;
while (1) {buff=str[j];	         if(buff>=0xC0) {j++; buff=str[j];}  j++;	
           if((buff==0) || (buff==RT_HW_BREAK_CHAR) || (len>lenMax) || (j>160)) {break;} 
		   if(buff>=0xC0) {j++;} //buff=str(j);
		   len++;} 		   
		   //len++;} 
return len;}
uint8_t getLenPGM(const char *text, uint8_t lenMax){ 	//==Получение Len из PROGMEM в формате utf-8 с учетом блокирующего символа '~'
	uint8_t buff,j,len; if(lenMax==0) {lenMax=80;} j=len=0;
while (1) {buff=pgm_read_byte(text+j);	j++;
		   if((buff==0) || (buff==RT_HW_BREAK_CHAR) || (len>lenMax) || (j>160)) {break;}
		   if(buff>=0xC0) {j++;} //buff=pgm_read_byte(text+j);
		   len++;} 
return len;}
uint8_t getNumberVal(uint32_t var, char mode, uint8_t len, uint8_t n){	//==Получение цифры из var(форматы mode=D,H,B) ее номеру(1:10) (начиная со старшей позиции);
uint32_t buff32=0;
if((n>len) || (n>10)) n=0; 
if(mode=='B') {buff32=(var>>(len-n))&1;}
if(mode=='H') {buff32=(var>>(len-n)*4)&0xf;}
if(mode=='D') {n=len-n+1; while(n!=0) {buff32=var; var/=10; buff32=buff32-(var*10); n--;};}
//if(buff32<=9) {buff32=buff32 +'0';} else {buff32=buff32-10+(upper ? 'A' : 'a') ;}
return (uint8_t)buff32;};
uint8_t getLenVal   (char mode, int32_t var){			                //==Получение кол-ва знаков в числе с оcнованиями 10,16,2 (DEC(I,U),HEX,BIN):
uint32_t v, buff; uint8_t len=0; uint8_t bs;
if(mode=='I') {if(var<0) {v=-var;} else {v=var;}	
								buff=bs=10;  len=1; for(int8_t i=0;i<10;i++) {if(v<buff){break;} buff=buff*bs; len++;} if(var<0) {len++;}} 
if(mode=='U') {v=(uint32_t)var; buff=bs=10;  len=1; for(int8_t i=0;i<10;i++) {if(v<buff){break;} buff=buff*bs; len++;}} 
if(mode=='H') {v=(uint32_t)var;	buff=bs=0xF; len=1; for(int8_t i=0;i<10;i++) {if(v<buff){break;} buff=buff*bs; len++;}} 
return len;};

int16_t getNumberFromString(String var, uint8_t n, char separator) {	//==Получение числа int16 из строки с разделителями(DEBUG !!!);
//--n позиция в строке начиная с 1. Если значения нет или =0, возвращает -32768;
int16_t x; int16_t findPoint; uint8_t startPoint,endPoint, len,i; String s;
 startPoint=endPoint=findPoint=0;  s=var; len=var.length();
 x=-32768;
 if(n==0) {return x;} i=1;
 do{if(i>n) break;
    if(startPoint>len) break;
	findPoint=var.indexOf(separator, startPoint);   
	if (findPoint==-1) {endPoint=len;} else {endPoint=findPoint;}
	if (n==i) {s=var.substring(startPoint,endPoint); s.trim(); if(s=="") {break;} x=s.toInt(); break;}  
	if (findPoint==-1)  break;
	startPoint=findPoint+1;	i++; 	
   } while (1);
return x;}	

String  getTextFromString  (String var, uint8_t n, char separator) {  	//==Получение текст (через разделители) из строки (DEBUG !!!);
//--n позиция в строке начиная с 1. Если значения нет или пробел, возвращает один пробел;
int16_t findPoint; 
uint8_t startPoint=0; 
uint8_t endPoint=0;
String x="";
String s=var; 
uint8_t len=var.length(); 									//--Длина строки;
uint8_t index=0;
do{if(index>n) {break;}
    if(startPoint>len) {break;}
	findPoint=var.indexOf(separator, startPoint);   
	if (findPoint==-1) {endPoint=len;} else {endPoint=findPoint;}
	if (n==index) {s=var.substring(startPoint,endPoint); s.trim(); 
				   if(s=="") {break;} 
				   x=s;       break;}  
	if (findPoint==-1)  {break;}
	startPoint=findPoint+1;	index++; 	
   } while (1);
return x;}
//=================================================================================================

/*
// получить число под индексом idx в списке list с разделителем div
int16_t getNumberFromStringnumFromList(char* list, int idx, char div) {
    uint8_t count = 0;
    char* p = list;
    while (1) {
        if (count++ == idx) return atoi(p);
        p = strchr(p, div);
        if (!p++) break;
    }
    return 0;
}
*/