//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//                       КОНВЕРТИРОВАНИЕ ПЕРЕМЕННЫХ БЕЗ ФОРМАТИРОВАНИЯ
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
String byteToBin (uint8_t  v){	//======Byte  ->String.BIN=========================================
uint8_t vMode=mess.signBit-48; if(vMode>9){vMode=0;} //--Преобразование текстовых цифр (0-9) в целое число;
uint8_t Qnt=mess.qntBit;  if(Qnt==0) {Qnt=8;} if(Qnt>8) {Qnt=8;} //==Нормализация кол-во выводимых бит;
String str; uint8_t len=0; bool a; uint8_t val=0;
if(mess.orderBit=='F'){val=v;} else {val=0; for(uint8_t i=1; i<=Qnt; i++) {bitWrite(val,(i-1),bitRead(v,(Qnt-i)));}}
if(mess.signBit==0){str=String('b'); len++;}  //if(Qnt>4){len++;}; 
for(uint8_t i=1; i<=Qnt; i++) {a=bitRead(val,(Qnt-i)); //if((((Qnt-i+1)==4)) && (i!=1)){str+=" ";}
if(a){str+=String((char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_1,vMode));} 
else {str+=String((char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_0,vMode));}} 
return str;};		
String wordToBin (uint16_t v){	//======Word  ->String.BIN=========================================
uint8_t vMode=mess.signBit-48; if(vMode>9){vMode=0;} //--Преобразование текстовых цифр (0-9) в целое число;
uint8_t Qnt=mess.qntBit;  if(Qnt==0) {Qnt=16;} if(Qnt>16) {Qnt=16;} //==Нормализация кол-во выводимых бит;
String str; uint8_t len=0; bool a; uint16_t val=0;
if(mess.orderBit=='F'){val=v;} else {val=0; for(uint8_t i=0; i<=Qnt; i++) {bitWrite(val,(i-1),bitRead(v,(Qnt-i)));}}
if(mess.signBit==0){str=String('b'); len++;} //if(Qnt>8){len++;};
for(uint8_t i=1; i<=Qnt; i++){a=bitRead(val,(Qnt-i)); //if((((Qnt-i+1)==8)) && (i!=1)){str+=" ";}
if(a){str+=String((char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_1,vMode));} 
else {str+=String((char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_0,vMode));}} 
//consoleVar(Qnt,','); consoleVar(str,'E'); 
return str;};
String longToBin (uint32_t v){	//======Long  ->String.BIN=========================================
uint8_t vMode=mess.signBit-48; if(vMode>9){vMode=0;} //--Преобразование текстовых цифр (0-9) в целое число;
uint8_t Qnt=mess.qntBit;  if(Qnt==0) {Qnt=32;} if(Qnt>32) {Qnt=32;} //==Нормализация кол-во выводимых бит;
String str; uint8_t len=0; bool a; uint32_t val=0;
if(mess.orderBit=='F'){val=v;} else {val=0; for(uint8_t i=0; i<=Qnt; i++) {bitWrite(val,(i-1),bitRead(v,(Qnt-i)));}}
if(mess.signBit==0){str=String('b'); len++;} //if(Qnt>8){len++;};
for(uint8_t i=1; i<=Qnt; i++){a=bitRead(val,(Qnt-i)); //if((((Qnt-i+1)==8)) && (i!=1)){str+=" ";}
if(a){str+=String((char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_1,vMode));} 
else {str+=String((char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_0,vMode));}} 
//consoleVar(Qnt,','); consoleVar(str,'E'); 
return str;};
String byteToLine (uint8_t v){ 	//======0-100%->String.Line========================================
uint8_t vMode=mess.signBit-48; if(vMode>9){vMode=0;} //--Преобразование текстовых цифр (0-9) в целое число;
String str=""; 
uint8_t Qnt=mess.qntBit;   if(Qnt==0){return str;} 
uint8_t a=v; if(a>100) {a=100;} 
a=((uint16_t)a*mess.qntBit)/100; 
for(uint8_t i=1; i<=a; i++){str+=String((char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_1,vMode));} 
//consoleVar(String("Line=")); consoleVar(str,'E');
return str;};
String pinToString(uint8_t v){	//======Byte  ->String.PIN     [mess.modePin::T,A,D]===============
String str="";
//-------------------------------------
#if defined(RT_HW_CORE_STM32)	
if(mess.modePin=='T') {str=getNamePin(v)+" "; 			return str;}
if(mess.modePin=='A') {str=getNamePin(v)+String('[');
						  if(v<254) {str+=String(v);} else{str+=String('*');} str+=String(']'); return str;}
//-------------------------
if(v<254) {str+=String(v);} else{str+=String('*');}    	return str;                    
//-------------------------------------
#elif defined(RT_HW_CORE_ESP8266)
if(mess.modePin=='T') {str=getNamePin(v); 			return str;}
if(mess.modePin=='A') {str=getNamePin(v)+String('[');
						  if(v<254){str+=String(v);} else{str+=String('*');} str+=String(']');  return str;}
//-------------------------------------
                          if(v<254){str =String(v);} else{str= String('*');} return str;
//-------------------------------------
#else
                          if(v<254){str+=String(v);} else{str= String(' ')+String('*');} return str; 	 		 
#endif		  
return str;};
String adrToString(uint8_t v){  //======Byte  ->String.adr.i2c [mess.modePin::D,H,A]===============
String str;
//-------------------------------------------------------------------------------------------------
if(mess.modeAdr=='H') {if(v<=127){str=String(F("0x")); if(v<0x0F) {str+=String('0');} str+=String(v,HEX);} 
                                                          else       {str=String(F(" ** "));}    return str;} 
//-------------------------------------------------------------------------------------------------
if(mess.modeAdr=='A') {if(v<=127){str=String(F("0x")); if(v<0x0F) {str+=String('0');} str+=String(v,HEX);} 
                                                          else {str=String(F(" ** "));} 
														  str+=String('/')+String(v);            return str;}
//-------------------------------------------------------------------------------------------------
str=String(v); return str;};
char   boolToChar (bool    v){	//======Bool  ->Char           [mode='0'-'9']======================	
uint8_t vMode=mess.signBit-48; if(vMode>9){vMode=0;} //--Преобразование текстовых цифр (0-9) в целое число;
if(v){return (char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_1,vMode);} 
else {return (char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_0,vMode);}};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//                       КОНВЕРТИРОВАНИЕ ПЕРЕМЕННЫХ С ФОРМАТИРОВАНИЕМ
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
String charToString(char    v, char mode='Z'){	//===formating char [mode:u,l,Z]	
String str=String(v);	
if(mode=='u'){str.toUpperCase();}
if(mode=='l'){str.toLowerCase();}
return str;};
String varToString (uint8_t v, char mode='Z'){	
//=================================================================================================
//					Конвертирование переменной uint8_t [mode:P,A,C,B,*,H,U,I,T,W,Z,z,1]
// 'A' - вывод адреса;
// 'B' - побитовый вывод, впереди старший байт;
// '*' - побитовый вывод, впереди младший байт;			
// 'H' - Шестнадцатеричный вывод в формате 0xFF;
// 'U' - Формат uint8_t(0-255),       форматированный вывод (добавляется пробелы дп размера поля, если его размер>0); 							
// 'I' - Формат  int8_t(-128 - +127); форматированный вывод (добавляется пробелы дп размера поля, если его размер>0); 		
// 'T' - Формат времени - если значении<0, впереди добавляется 0;
// 'W' - Формат недопустимого значения - если оно >=254, выводится *;
// 'z' - Формат  int8_t(-128 - +127); неформатированный вывод (размер поля определяется количеством значащих цифр в числе);
// 'Z' - Формат uint8_t(0-255);       неформатированный вывод (размер поля определяется количеством значащих цифр в числе);
// '1' - Вывод значения int8_t  в десятичной форме с одним знаком после точки;
// 'X' - Вывод в форме линии (линейный индикатор);
// 'C' - Вывод числа в символьной форме;
//=================================================================================================
String str=String(v);	
uint8_t sz=mess.size;
char alig=mess.alig; 	
char signBit=mess.signBit; 
char orderBit=mess.orderBit; 
char qntBit=mess.qntBit; if(mess.qntBit>8) {mess.qntBit=8;}
//-------------------------------------
if(mode=='P') {str=pinToString(v);  mess.alig='R';
  if(sz==0) {mess.alig='N';} else{
#if defined(RT_HW_CORE_STM32)
if(sz<3) {sz=3;}
if(mess.modePin=='A') {if(sz<8) {sz=9;} mess.alig='L';}
if(mess.modePin=='T') {if(sz<4) {sz=4;} mess.alig='L';}
#endif
#if defined(RT_HW_CORE_ESP8266)
if(sz<2) {sz=2;}
if(mess.modePin=='A') {if(sz<7) {sz=7;}}
if(mess.modePin=='T') {if(sz<3) {sz=3;}}
#endif
}}
//-----------------------------------
if(mode=='A') {str=adrToString(v);}
if(mode=='B') {mess.orderBit='F'; str=byteToBin(v);} 
if(mode=='*') {mess.orderBit='B'; str=byteToBin(v);}			
if(mode=='H') {str=String(v,HEX); str.toUpperCase(); if(v<=0xF){str="0"+str;} str="0x"+str;}
if(mode=='U') {str=String(v);}								
if(mode=='I') {str=String(int8_t(v));}
if(mode=='T') {str=String(v); if(v<10)  {str=String("0")+str;}}
if(mode=='W') {mess.alig='N'; if(v<254) {str=String(v);} else {str=String('*');}}
if(mode=='z') {mess.alig='N'; str=String((uint8_t)v);}
if(mode=='Z') {mess.alig='N'; str=String(int8_t(v));}
if(mode=='1') {str=String(float(int8_t(v)/10.0),1);}
if(mode=='X') {str=byteToLine(v);}
if(mode=='C') {str=String(char(v));}
mess.alig=alig;  mess.signBit=signBit; mess.orderBit=orderBit; mess.qntBit=qntBit;
return str;}
String varToString ( int8_t v, char mode='Z'){
	return varToString((uint8_t)v,mode);}
String varToString( int16_t v, char mode='Z'){	
//=================================================================================================
//					Конвертирование переменной int16_t [mode:B,*,H,U,I,0,1,2,3,Z,z]
// 'B' - побитовый вывод, впереди старший байт;
// '*' - побитовый вывод, впереди младший байт;			
// 'H' - Шестнадцатеричный вывод в формате 0xFF;
// 'U' - Формат uint16_t(0-65535),           форматированный вывод (добавляется пробелы для размера поля, если его размер>0); 							
// 'I' - Формат  int16_t(-32768 - +32767);   форматированный вывод (добавляется пробелы для размера поля, если его размер>0); 
// 'z' - Формат  int16_t(-32768 - +32767); неформатированный вывод (размер поля определяется количеством значащих цифр в числе);
// 'Z' - Формат  uin16_t(0-65535);         неформатированный вывод (размер поля определяется количеством значащих цифр в числе);
// '0' - Вывод значения int16_t  в десятичной форме;
// '1' - Вывод значения int16_t  в десятичной форме с одним знаком  после точки;
// '2' - Вывод значения int16_t  в десятичной форме с двумя знаками после точки;
// '3' - Вывод значения int16_t  в десятичной форме с тремя знаками после точки;
//=================================================================================================	
String str=String(v); 
char signBit=mess.signBit; char orderBit=mess.orderBit; char qntBit=mess.qntBit;
if(mode=='B') {mess.orderBit='F'; 		str=wordToBin(uint16_t(v));} 
if(mode=='*') {mess.orderBit='B';		str=wordToBin(uint16_t(v));} 				
if(mode=='H') {str=String((uint16_t)v,HEX); str.toUpperCase(); uint8_t len=str.length(); for(uint8_t i=len; i<4; i++){str="0"+str;} str="0x"+str;}
if(mode=='U') {str=String(uint16_t(v));}								
if(mode=='I') {str=String(v);}	
if(mode=='0') {str=String(float(v/1.0),0)+String(F(".0"));}
if(mode=='1') {str=String(float(v/10.0),1);}
if(mode=='2') {str=String(float(v/100.0),2);}
if(mode=='3') {str=String(float(v/1000.0),3);}
if(mode=='z') {mess.alig='N'; str=String(uint16_t(v));}
if(mode=='Z') {mess.alig='N'; str=String( int16_t(v));}
mess.signBit=signBit; 		mess.orderBit=orderBit; 	mess.qntBit=qntBit;
return str;}
String varToString(uint16_t v, char mode='Z'){
//=================================================================================================
//					Конвертирование переменной uint16_t 
//=================================================================================================
	return varToString((int16_t)v,mode);}
String varToString( int32_t v, char mode='Z'){	//===formating int32_t  [mode:U,I,0,1,2,3,Z,z]=====	
//-------------------------------------------------------------------------------------------------
// mode:
// 'B' - побитовый вывод, впереди старший байт;
// '*' - побитовый вывод, впереди младший байт;			
// 'H' - Шестнадцатеричный вывод в формате 0xFF;
// 'U' - Формат uint32_t(0-4294967295),                форматированный вывод (добавляется пробелы дп размера поля, если его размер>0); 							
// 'I' - Формат  int32_t(-2147483648 - +2147483647);   форматированный вывод (добавляется пробелы для размера поля, если его размер>0); 
// 'z' - Формат  int32_t(-2147483648 - +2147483647); неформатированный вывод (размер поля определяется количеством значащих цифр в числе);
// 'Z' - Формат uint32_t(0-4294967295);       неформатированный вывод (размер поля определяется количеством значащих цифр в числе);
// '0' - Вывод значения int32_t  в десятичной форме;
// '1' - Вывод значения int32_t  в десятичной форме с одним знаком  после точки;
// '2' - Вывод значения int32_t  в десятичной форме с двумя знаками после точки;
// '3' - Вывод значения int32_t  в десятичной форме с тремя знаками после точки;
//=================================================================================================	
String str=String(v);	
char signBit=mess.signBit; char orderBit=mess.orderBit; char qntBit=mess.qntBit; 				
if(mode=='B') {mess.orderBit='F'; 		str=longToBin(uint32_t(v));} 
if(mode=='*') {mess.orderBit='B';		str=longToBin(uint32_t(v));} 
if(mode=='H') {str=String((uint32_t)v,HEX); str.toUpperCase(); uint8_t len=str.length(); for(uint8_t i=len; i<8; i++){str="0"+str;} str="0x"+str;}
if(mode=='U') {str=String(uint32_t(v));}								
if(mode=='I') {str=String( int32_t(v));}	
if(mode=='0') {str=String(float(v/1.0),0)+String(F(".0"));}
if(mode=='1') {str=String(float(v/10.0),1);}
if(mode=='2') {str=String(float(v/100.0),2);}
if(mode=='3') {str=String(float(v/1000.0),3);}
if(mode=='z') {mess.alig='N'; str=String(uint32_t(v));}
if(mode=='Z') {mess.alig='N'; str=String(int32_t(v));}
mess.signBit=signBit; 		mess.orderBit=orderBit; 	mess.qntBit=qntBit;
return str;}
String varToString(uint32_t v, char mode='Z'){  //===formating uint32_t [mode:U,I,0,1,2,3,Z,z]=====	
	return varToString((int32_t)v, mode);}
String varToString(float    v, char mode='2'){  //===formating float    [mode:0,1,2,3,Z]===========
//-------------------------------------------------------------------------------------------------
//					Конвертирование переменной float [mode:0,1,2,3,Z]
// '0' - Вывод значения float  в дробной форме;
// '1' - Вывод значения float  в дробной форме с одним знаком  после точки;
// '2' - Вывод значения float  в дробной форме с двумя знаками после точки;
// '3' - Вывод значения float  в дробной форме с тремя знаками после точки;
// 'Z' - Вывод значения float  в дробной форме с двумя знаками после точки;
//-------------------------------------------------------------------------------------------------				
String str=String(v,2);		 	
if(mode=='0') {str=String(v,0);}
if(mode=='1') {str=String(v,1);}
if(mode=='2') {str=String(v,2);}
if(mode=='3') {str=String(v,3);}
if(mode=='Z') {str=String(v);}	
return str;};
String varToString(String   v, char mode='Z'){  //===formating String   [mode:u,l,Z]===============		
//-------------------------------------------------------------------------------------------------
// mode:
// 'u' - вывод строки заглавными буквами;
// 'l' - вывод строки прописными буквами;
// 'Z' - неформатированный вывод;
//-------------------------------------------------------------------------------------------------
String str=v; 	
if(mode=='u') {str.toUpperCase();}
if(mode=='l') {str.toLowerCase();}
return str;};
//=================================================================================================
