//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//										API функций SPN
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//=================================================================================================
//										Настройка пинов и устройства
//=================================================================================================







uint8_t  SPNinitBus   (RT_HW_STRUCT_SPN &spn, uint8_t &codeErr, uint8_t sck, uint8_t miso, uint8_t mosi, uint8_t cs,  uint8_t speed=0){ //++++ИНИЦИАЛИЗАЦИЯ SPN========================
codeErr=0; spn.status=0;
spn.speed=speed;
if(spn.speed>100){spn.speed=100;} spn.time=10-(spn.speed/10);
spn.idSCK.pin=sck; spn.idMISO.pin=miso; spn.idMOSI.pin=mosi; spn.idCS.pin=cs; 
spn.permitRX=spn.permitTX=0;
if(spn.codeErr==0){                        if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spn.idSCK.pin)) {spn.codeErr=65;}}							//--Ошибка,если не допустимый номер пина sck;
if(spn.codeErr==0){if(spn.idMISO.pin!=255){if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spn.idMISO.pin)){spn.codeErr=66;} else{spn.permitRX=1;}}}	//--Ошибка, если не допустимый номер пина miso;	
if(spn.codeErr==0){if(spn.idMOSI.pin!=255){if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spn.idMOSI.pin)){spn.codeErr=67;} else{spn.permitTX=1;}}}	//--Ошибка, если не допустимый номер пина mosi;
if(spn.codeErr==0){if(spn.idCS.pin  !=255){if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spn.idCS.pin  )){spn.codeErr=68;}}}	                        //--Ошибка, если не допустимый номер пина cs;
if(spn.codeErr==0){spn.status=1;
				   RT_HW_PIN_DIR_SET_ID(spn.idCS,  spn.idCS.pin);   RT_HW_PIN_DIR_WRITE_HIGH(spn.idCS);   RT_HW_PIN_DIR_MODE_OUTPUT(spn.idCS);
                   RT_HW_PIN_DIR_SET_ID(spn.idSCK, spn.idSCK.pin);  RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK);  RT_HW_PIN_DIR_MODE_OUTPUT(spn.idSCK);
  if(spn.permitTX){RT_HW_PIN_DIR_SET_ID(spn.idMOSI,spn.idMOSI.pin); RT_HW_PIN_DIR_WRITE_HIGH(spn.idMOSI); RT_HW_PIN_DIR_MODE_OUTPUT(spn.idMOSI);}
  if(spn.permitRX){RT_HW_PIN_DIR_SET_ID(spn.idMISO,spn.idMISO.pin);                                       RT_HW_PIN_DIR_MODE_INPUT(spn.idMISO);}
}
//consoleTest(String(F("init SPN codeErr")),spn.codeErr,';'); 
//consoleTest(String(F(" status")),spn.status,';'); 
//consoleTest(String(F(" time")),spn.time,';'); 
//consoleTest(String(F(" sck")),spn.idSCK.pin,';');  consoleTest(String(F(" miso")),spn.idMISO.pin,';'); 
//consoleTest(String(F(" mosi")),spn.idMOSI.pin,';'); consoleTest(String(F(" cs")),spn.idCS.pin,';'); 
//consoleTest(String(F(" PermitRX")),spn.permitRX,';'); consoleTest(String(F(" PermitTX")),spn.permitTX,';');
//consoleCR();
return 1;
};	//+++++END SPNinitBus()========================================================================
uint8_t  SPNinitDevice(RT_HW_STRUCT_SPN &spn, uint8_t &codeErr){ //++++ИНИЦИАЛИЗАЦИЯ SPN========
spn.codeErr=0; spn.status=0;
if(spn.speed>100){spn.speed=100;} spn.time=10-(spn.speed/10);
spn.permitRX=spn.permitTX=0;
if(spn.codeErr==0){                        if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spn.idSCK.pin)){spn.codeErr=65;}}							//--Ошибка,если не допустимый номер пина sck;
if(spn.codeErr==0){if(spn.idMISO.pin!=255){if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spn.idMISO.pin)){spn.codeErr=66;} else{spn.permitRX=1;}}}	//--Ошибка, если не допустимый номер пина miso;	
if(spn.codeErr==0){if(spn.idMOSI.pin!=255){if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spn.idMOSI.pin)){spn.codeErr=67;} else{spn.permitTX=1;}}}	//--Ошибка, если не допустимый номер пина mosi;
if(spn.codeErr==0){if(spn.idCS.pin  !=255){if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spn.idCS.pin  )){spn.codeErr=68;}}}	                        //--Ошибка, если не допустимый номер пина cs;
if(spn.codeErr==0){spn.status=1;
				   RT_HW_PIN_DIR_SET_ID(spn.idCS,  spn.idCS.pin);   RT_HW_PIN_DIR_WRITE_HIGH(spn.idCS);   RT_HW_PIN_DIR_MODE_OUTPUT(spn.idCS);
                   RT_HW_PIN_DIR_SET_ID(spn.idSCK, spn.idSCK.pin);  RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK);  RT_HW_PIN_DIR_MODE_OUTPUT(spn.idSCK);
  if(spn.permitTX){RT_HW_PIN_DIR_SET_ID(spn.idMOSI,spn.idMOSI.pin); RT_HW_PIN_DIR_WRITE_HIGH(spn.idMOSI); RT_HW_PIN_DIR_MODE_OUTPUT(spn.idMOSI);}
  if(spn.permitRX){RT_HW_PIN_DIR_SET_ID(spn.idMISO,spn.idMISO.pin);                                       RT_HW_PIN_DIR_MODE_INPUT(spn.idMISO);}
}
//consoleTest(String(F("init SPN codeErr")),spn.codeErr,';'); 
//consoleTest(String(F(" status")),spn.status,';'); 
//consoleTest(String(F(" time")),spn.time,';'); 
//consoleTest(String(F(" sck")),spn.idSCK.pin,';');  consoleTest(String(F(" miso")),spn.idMISO.pin,';'); 
//consoleTest(String(F(" mosi")),spn.idMOSI.pin,';'); consoleTest(String(F(" cs")),spn.idCS.pin,';'); 
//consoleTest(String(F(" PermitRX")),spn.permitRX,';'); consoleTest(String(F(" PermitTX")),spn.permitTX,';');
//consoleCR();
return 1;
};	//+++++END SPNinitDevice()=====================================================================
uint8_t  SPNgetPinSCK() {return readArrPGM(RT_HW_PGM_PIN_SPN_ID,0);}
uint8_t  SPNgetPinMISO(){return readArrPGM(RT_HW_PGM_PIN_SPN_ID,1);}
uint8_t  SPNgetPinMOSI(){return readArrPGM(RT_HW_PGM_PIN_SPN_ID,2);}
uint8_t  SPNgetPinCS()  {return readArrPGM(RT_HW_PGM_PIN_SPN_ID,3);}
void     SPNsetSpeed  (RT_HW_STRUCT_SPN &spn, uint8_t speed){ //++++УСТАНОВКА СКОРОСТИ SPN(0-100%)
if(spn.speed>100){spn.speed=0;} 
if(spn.speed==0) {spn.time=RT_HW_SPN_DELAY;} else{spn.time=10-(speed/10);}
};	//++++SPNsetSpeed()
void 	 SPNtransfer  (RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint8_t  tx, uint8_t  &rx){				 
RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);	RT_HW_PIN_DIR_WRITE_LOW(spn.idCS);	rx=0;		//--Установка SCK в LOW, установка пина CS в LOW; 
if(bitOrder){tx=reverseV8(tx);};												//--Реверс бит tx для режима MSBFIRST;											
//consoleTest(String(F("SPN tx")),tx,'E','H');
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=7; spn.idx++){												//--Побитовый ввод/вывод;
 if(spn.permitTX){     RT_HW_PIN_DIR_WRITE(spn.idMOSI,(tx & (uint8_t)1<<(7-spn.idx)));}	//--Побитовая запись переменной;
                       RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				       RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
 if(spn.permitRX){  if(RT_HW_PIN_DIR_READ(spn.idMISO)){rx |=(uint8_t)1<<(7-spn.idx);}} 	//--Побитовое чтение измеряемого параметра;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(spn.idCS); if(spn.permitTX){RT_HW_PIN_DIR_WRITE_LOW(spn.idMOSI);}	//--Установка CS,MOSI в исходное состояние;	
if(bitOrder){rx=reverseV8(rx);} 								//--Реверс бит для режима MSBFIRST
};	//++++END SPNtransfer()======================================================================= 
void 	 SPNtransfer16(RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint16_t tx, uint16_t &rx){					 
RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);	RT_HW_PIN_DIR_WRITE_LOW(spn.idCS);	rx=0;		//--Установка SCK в LOW, установка пина CS в LOW; 
if(bitOrder){tx=reverseV16(tx);};												//--Реверс бит tx для режима MSBFIRST;																						
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=15; spn.idx++){												//--Побитовый ввод/вывод;
 if(spn.permitTX){     RT_HW_PIN_DIR_WRITE(spn.idMOSI,(tx & (uint16_t)1<<(15-spn.idx)));}		//--Побитовая запись переменной;
                       RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				       RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
 if(spn.permitRX){  if(RT_HW_PIN_DIR_READ(spn.idMISO)){rx |=(uint16_t)1<<(15-spn.idx);}}		//--Побитовое чтение измеряемого параметра;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(spn.idCS); if(spn.permitTX){RT_HW_PIN_DIR_WRITE_LOW(spn.idMOSI);}	//--Установка CS,MOSI в исходное состояние;	
if(bitOrder){rx=reverseV16(rx);} 								//--Реверс бит для режима MSBFIRST
};	//++++END SPNtransfer()======================================================================= 
void 	 SPNtransfer24(RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint32_t tx, uint32_t &rx){				 
RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);	RT_HW_PIN_DIR_WRITE_LOW(spn.idCS);	rx=0;		//--Установка SCK в LOW, установка пина CS в LOW; 
if(bitOrder){tx=reverseV24(tx);};													//--Реверс бит tx для режима MSBFIRST;																						
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=23; spn.idx++){												//--Побитовый ввод/вывод;
 if(spn.permitTX){     RT_HW_PIN_DIR_WRITE(spn.idMOSI,(tx& (uint32_t)1<<(23-spn.idx)));}//--Побитовая запись переменной;
                       RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				       RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
 if(spn.permitRX){if(RT_HW_PIN_DIR_READ(spn.idMISO)){rx |=(uint32_t)1<<(23-spn.idx);}} 	//--Побитовое чтение измеряемого параметра;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(spn.idCS); if(spn.permitTX){RT_HW_PIN_DIR_WRITE_LOW(spn.idMOSI);}	//--Установка CS,MOSI в исходное состояние;	
if(bitOrder){rx=reverseV24(rx);} 								//--Реверс бит для режима MSBFIRST
};	//++++END SPNtransfer24()======================================================================
void 	 SPNtransfer32(RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint32_t tx, uint32_t &rx){					 
RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);	RT_HW_PIN_DIR_WRITE_LOW(spn.idCS);	rx=0;		//--Установка SCK в LOW, установка пина CS в LOW; 
if(bitOrder){tx=reverseV32(tx);};												//--Реверс бит tx для режима MSBFIRST;																						
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=31; spn.idx++){												//--Побитовый ввод/вывод;
 if(spn.permitTX){   RT_HW_PIN_DIR_WRITE(spn.idMOSI,(tx & (uint32_t)1<<(31-spn.idx)));}	//--Побитовая запись переменной;
                     RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				     RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
 if(spn.permitRX){if(RT_HW_PIN_DIR_READ(spn.idMISO)){rx |=(uint32_t)1<<(31-spn.idx);}} 	//--Побитовое чтение измеряемого параметра;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(spn.idCS); if(spn.permitTX){RT_HW_PIN_DIR_WRITE_LOW(spn.idMOSI);}	//--Установка CS,MOSI в исходное состояние;	
if(bitOrder){rx=reverseV32(rx);} 								//--Реверс бит для режима MSBFIRST
};	//++++END SPNtransfer32()=======================================================================  

void 	 SPNwrite  (RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint8_t  tx){				 
RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);	RT_HW_PIN_DIR_WRITE_LOW(spn.idCS);		    //--Установка SCK в LOW, установка пина CS в LOW; 
if(bitOrder){tx=reverseV8(tx);};												//--Реверс бит tx для режима MSBFIRST;											
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=7; spn.idx++){												//--Побитовый ввод/вывод;
 if(spn.permitTX){     RT_HW_PIN_DIR_WRITE(spn.idMOSI,(tx & (uint8_t)1<<(7-spn.idx)));}	//--Побитовая запись переменной;
                       RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				       RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(spn.idCS); if(spn.permitTX){RT_HW_PIN_DIR_WRITE_LOW(spn.idMOSI);}	//--Установка CS,MOSI в исходное состояние;	
};	//++++END SPNtransfer()======================================================================= 
void 	 SPNwrite16(RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint16_t tx){					 
RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);	RT_HW_PIN_DIR_WRITE_LOW(spn.idCS);      		//--Установка SCK в LOW, установка пина CS в LOW; 
if(bitOrder){tx=reverseV16(tx);};													//--Реверс бит tx для режима MSBFIRST;																						
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=15; spn.idx++){												//--Побитовый ввод/вывод;
 if(spn.permitTX){     RT_HW_PIN_DIR_WRITE(spn.idMOSI,(tx & (uint16_t)1<<(15-spn.idx)));}		//--Побитовая запись переменной;
                       RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				       RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(spn.idCS); if(spn.permitTX){RT_HW_PIN_DIR_WRITE_LOW(spn.idMOSI);}	//--Установка CS,MOSI в исходное состояние;	
};	//++++END SPNtransfer()======================================================================= 
void 	 SPNwrite24(RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint32_t tx){				 
RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);	RT_HW_PIN_DIR_WRITE_LOW(spn.idCS);	     		//--Установка SCK в LOW, установка пина CS в LOW; 
if(bitOrder){tx=reverseV24(tx);};													//--Реверс бит tx для режима MSBFIRST;																						
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=23; spn.idx++){												//--Побитовый ввод/вывод;
 if(spn.permitTX){     RT_HW_PIN_DIR_WRITE(spn.idMOSI,(tx& (uint32_t)1<<(23-spn.idx)));}//--Побитовая запись переменной;
                       RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				       RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(spn.idCS); if(spn.permitTX){RT_HW_PIN_DIR_WRITE_LOW(spn.idMOSI);}	//--Установка CS,MOSI в исходное состояние;	
};	//++++END SPNtransfer24()======================================================================
void 	 SPNwrite32(RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint32_t tx){					 
RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);	RT_HW_PIN_DIR_WRITE_LOW(spn.idCS);  		//--Установка SCK в LOW, установка пина CS в LOW; 
if(bitOrder){tx=reverseV32(tx);};												//--Реверс бит tx для режима MSBFIRST;																						
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=31; spn.idx++){												//--Побитовый ввод/вывод;
 if(spn.permitTX){   RT_HW_PIN_DIR_WRITE(spn.idMOSI,(tx & (uint32_t)1<<(31-spn.idx)));}	//--Побитовая запись переменной;
                     RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				     RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(spn.idCS); if(spn.permitTX){RT_HW_PIN_DIR_WRITE_LOW(spn.idMOSI);}	//--Установка CS,MOSI в исходное состояние;	
};	//++++END SPNtransfer32()=======================================================================  

void 	 SPNread  (RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint8_t  &rx){				 
RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);	RT_HW_PIN_DIR_WRITE_LOW(spn.idCS);	rx=0;		//--Установка SCK в LOW, установка пина CS в LOW; 
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=7; spn.idx++){												//--Побитовый ввод/вывод;
                       RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				       RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
 if(spn.permitRX){  if(RT_HW_PIN_DIR_READ(spn.idMISO)){rx |=(uint8_t)1<<(7-spn.idx);}} 	//--Побитовое чтение измеряемого параметра;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(spn.idCS);                                                 //--Установка CS,MOSI в исходное состояние;	
if(bitOrder){rx=reverseV8(rx);} 													//--Реверс бит для режима MSBFIRST
};	//++++END SPNtransfer()======================================================================= 
void 	 SPNread16(RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint16_t &rx){					 
RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);	RT_HW_PIN_DIR_WRITE_LOW(spn.idCS); rx=0;																					
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=15; spn.idx++){												//--Побитовый ввод/вывод;
                       RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				       RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
 if(spn.permitRX){  if(RT_HW_PIN_DIR_READ(spn.idMISO)){rx |=(uint16_t)1<<(15-spn.idx);}}		//--Побитовое чтение измеряемого параметра;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(spn.idCS);                                                 //--Установка CS,MOSI в исходное состояние;	
if(bitOrder){rx=reverseV16(rx);} 								//--Реверс бит для режима MSBFIRST
};	//++++END SPNtransfer()======================================================================= 
void 	 SPNread24(RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint32_t &rx){				 
RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);	RT_HW_PIN_DIR_WRITE_LOW(spn.idCS);	rx=0;		//--Установка SCK в LOW, установка пина CS в LOW; 																					
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=23; spn.idx++){												//--Побитовый ввод/вывод;
                       RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				       RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
 if(spn.permitRX){if(RT_HW_PIN_DIR_READ(spn.idMISO)){rx |=(uint32_t)1<<(23-spn.idx);}} 	//--Побитовое чтение измеряемого параметра;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(spn.idCS);                                              	//--Установка CS,MOSI в исходное состояние;	
if(bitOrder){rx=reverseV24(rx);} 								//--Реверс бит для режима MSBFIRST
};	//++++END SPNtransfer24()======================================================================
void 	 SPNread32(RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint32_t &rx){					 
RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);	RT_HW_PIN_DIR_WRITE_LOW(spn.idCS);	rx=0;		//--Установка SCK в LOW, установка пина CS в LOW; 																					
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=31; spn.idx++){												//--Побитовый ввод/вывод;
                     RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				     RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
 if(spn.permitRX){if(RT_HW_PIN_DIR_READ(spn.idMISO)){rx |=(uint32_t)1<<(31-spn.idx);}} 	//--Побитовое чтение измеряемого параметра;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(spn.idCS);	//--Установка CS,MOSI в исходное состояние;	
if(bitOrder){rx=reverseV32(rx);} 								//--Реверс бит для режима MSBFIRST
};	//++++END SPNtransfer32()=======================================================================  

void 	 spnRead  (RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint8_t  &rx){				 
rx=0;																					
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=7; spn.idx++){												//--Побитовый ввод/вывод;
                       RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				       RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
 if(spn.permitRX){  if(RT_HW_PIN_DIR_READ(spn.idMISO)){rx |=(uint8_t)1<<(7-spn.idx);}} 	//--Побитовое чтение измеряемого параметра;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
if(bitOrder){rx=reverseV8(rx);} 													//--Реверс бит для режима MSBFIRST
};	//++++END SPNtransfer()======================================================================= 
void 	 spnRead16(RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint16_t &rx){					 
rx=0;																					
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=15; spn.idx++){												//--Побитовый ввод/вывод;
                       RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				       RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
 if(spn.permitRX){  if(RT_HW_PIN_DIR_READ(spn.idMISO)){rx |=(uint16_t)1<<(15-spn.idx);}}		//--Побитовое чтение измеряемого параметра;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
if(bitOrder){rx=reverseV16(rx);} 								//--Реверс бит для режима MSBFIRST
};	//++++END SPNtransfer()======================================================================= 
void 	 spnRead24(RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint32_t &rx){				 
rx=0;		//--Установка SCK в LOW, установка пина CS в LOW; 																					
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=23; spn.idx++){												//--Побитовый ввод/вывод;
                       RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				       RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
 if(spn.permitRX){if(RT_HW_PIN_DIR_READ(spn.idMISO)){rx |=(uint32_t)1<<(23-spn.idx);}} 	//--Побитовое чтение измеряемого параметра;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(spn.idCS);                                              	//--Установка CS,MOSI в исходное состояние;	
if(bitOrder){rx=reverseV24(rx);} 								//--Реверс бит для режима MSBFIRST
};	//++++END SPNtransfer24()======================================================================
void 	 spnRead32(RT_HW_STRUCT_SPN &spn, uint8_t bitOrder, uint32_t &rx){					 
rx=0;		//--Установка SCK в LOW, установка пина CS в LOW; 																					
//-------------------------------------------------------------------------------------------------
for(spn.idx=0; spn.idx<=31; spn.idx++){												//--Побитовый ввод/вывод;
                     RT_HW_PIN_DIR_WRITE_LOW(spn.idSCK);  RT_HW_DELAY(spn.time);	//--Строб  SCK
				     RT_HW_PIN_DIR_WRITE_HIGH(spn.idSCK); RT_HW_DELAY(spn.time); 	//            с задержкой;
 if(spn.permitRX){if(RT_HW_PIN_DIR_READ(spn.idMISO)){rx |=(uint32_t)1<<(31-spn.idx);}} 	//--Побитовое чтение измеряемого параметра;
}																					//--END for();
//-------------------------------------------------------------------------------------------------
if(bitOrder){rx=reverseV32(rx);} 								//--Реверс бит для режима MSBFIRST
};	//++++END SPNtransfer32()=======================================================================  

//=================================================================================================
