//=================================================================================================
//								СЕРВИСНЫЕ ФУНКЦИИ
//=================================================================================================
void LcdGenerator (RT_HW_LCD44780_PARAM_ID &id){                 	 //++++Генератор run:=0-wait; =1-output; =2-output for change; =3-clear;
id.run=0;
id.extGen=getGenState(id.num);		//--Получение значения от генератора;
//++++++++++++Обработка главного тактирующего генератора-------------------------------------------
if(id.agoGen==id.extGen){return;}	//--Выход, если нет изменений генератора;
id.agoGen=id.extGen;				//--Фиксация значения генератора;			
if(id.agoGen>=2){id.agoBit=id.first=0; id.cntEN=id.cntLimit=id.cntTask=0; id.agoEN=id.extEN;}
if( id.extEN){		//+++++Обработка EN=1------------------------------------------------------------------
 if(id.agoEN!=id.extEN){id.agoEN=id.extEN; id.first=0; id.cntEN=0;} 		//--Фиксация изменения со сбросом счетчика задержки; 
 if(id.first==0) {if(++id.cntEN>5){id.first=1; id.run=1;}  return;}}		//--Задержка после EN=1, для того, чтобы устранения конфликта с другим выводом;
if(!id.extEN){		//+++++Обработка EN=0--------------------------------------------------------------
 if(id.agoEN!=id.extEN){id.agoEN=id.extEN;          id.run=3; return;}}	    //--Безусловный запуск очистки поля;
//------
// Мерцание
//-----  
if(id.modeBlink==0){id.cntBlink=0; id.blink=0;}
if(id.modeBlink==1){++id.cntBlink; 
    if(id.cntBlink>=id.periodBlink){	
	id.cntBlink=0; id.blink=!id.blink; if(id.blink){id.run=3;} else{id.run=1;}} return;}
//-------------------------------------------------------------------------------------------------
if(id.modeTask=='C'){if(++id.cntLimit>=id.periodLimit){id.cntLimit=0;				 id.run=2;} return;} //--По изменению условий(переменных);
if(id.modeTask=='P'){if(++id.cntTask >=id.periodTask) {id.cntTask =0; 				 id.run=1;} return;} //--Периодический безусловный;
if(id.modeTask=='T'){if(++id.cntTask >=id.periodTask) {id.cntTask =0; 				 id.run=2;} return;} //--Периодически & по изменению условий(переменных); 
if(id.modeTask=='A'){if(++id.cntLimit>=id.periodLimit){id.cntLimit=0;                id.run=2;}          //--По изменению условий(переменных);
                     if(++id.cntTask >=id.periodTask) {id.cntTask =0; id.cntLimit=0; id.run=1;} return;} //--       или периодический безусловный; 
}; 	//++++END LcdGenerator()-----------------------------------------------------------------------
void LcdPreparData(RT_HW_LCD44780_PARAM_ID &id, const char *head){	//++++Подготовка численной переменной;
//-------------------------------------------------------------------------------------------------
arrReset(id.num);   //--Сброс массива вывода;
if(id.cmdRun==3){for(id.idx=0; id.idx<id.len; id.idx++){arrWrite(id.num,' ');} arrReset(id.num); return;}
//-------------------------------Расчет длины поля заголовка и суффикса----------------------------
if(id.msLenHead==255){id.xSrc=0; if(!(getCharLcdPGM(head,id.xSrc)=='~')){id.msLenHead=getLenPGM(head,id.len);} else{id.msLenHead=0;}}//--Одноразовая фиксация размера заголовка; 
if(id.suff=='~')     {id.msLenSuff=0;} else{id.msLenSuff=1;}							//--Размер суффикса;
//-------------------------------Расчет длины поля переменной--------------------------------------
id.msLenVar=0;
if(id.formatVar=='I'){id.msLenVar=String(id.agoVar).length();}
if(id.formatVar=='U'){if(id.agoVar>=0){id.msLenVar=String(id.agoVar).length();} else{id.msLenVar=String((uint32_t)(-id.agoVar)).length();}}
if(id.formatVar=='0'){id.msLenVar=String(id.agoVar).length();}
if(id.formatVar=='1'){id.msLenVar=String((float)id.agoVar/10,1).length();}
if(id.formatVar=='2'){id.msLenVar=String((float)id.agoVar/100,2).length();}
if(id.formatVar=='3'){id.msLenVar=String((float)id.agoVar/1000,3).length();}
if(id.formatVar=='H'){if(id.modeVar=='B'){id.msLenVar=2;} if(id.modeVar=='W'){id.msLenVar=4;} if(id.modeVar=='L'){id.msLenVar=8;}}
if(id.formatVar=='#'){if(id.modeVar=='B'){id.msLenVar=8;} if(id.modeVar=='W'){id.msLenVar=16;}}
if(id.formatVar=='*'){if(id.modeVar=='B'){id.msLenVar=8;} if(id.modeVar=='W'){id.msLenVar=16;}}
if(id.formatVar=='='){id.msLenVar=4;}
if(id.formatVar=='-'){id.msLenVar=4;}
//if(id.formatVar=='X'){id.msLenVar=(id.agoVar&0xFFFF)*(id.len-id.msLenSuff)/100;} 		//--Размер переменной для X;
//-----------------Нормализация длины полей заголовка, переменной, суффикса общей длины поля--------- 
   if(( id.msLenHead+id.msLenVar+id.msLenSuff)> id.len){id.msLenSuff=0;}	                        //--Нормализация длины суффикса;
do{if(((id.msLenHead+id.msLenVar)<=id.len) ||(id.msLenHead==0)){break;} id.msLenHead--;} while(1);	//--Нормализация длины заголовка;		   
do{if(((id.msLenVar)<=id.len) ||(id.msLenVar==0))              {break;} id.msLenVar--;}  while(1);	//--Нормализация длины значения;
//----------------------------------Расчет Begin и End заполнителей----------------------------------
id.msLenBegin=getLenBegin(id);	 id.msLenEnd=getLenEnd(id); 		
//---------------------------------------------------------------------------------------------------
if(id.msLenBegin>0){          for(id.idx=0; id.idx<id.msLenBegin; id.idx++){arrWrite(id.num,' ');}}	//--Запись Begin-заполнителей; 																																		//--Очистка индекса для getCharLcdPGM();
if(id.msLenHead>0) {id.xSrc=0;for(id.idx=0; id.idx<id.msLenHead;  id.idx++){arrWrite(id.num,getCharLcdPGM(head,id.xSrc));}}  //--Запись заголовка;
//------------------------------------------Запись переменной----------------------------------------
if(id.msLenVar>0){
String bs;
if(id.formatVar=='I'){bs=String(id.agoVar);}
if(id.formatVar=='U'){if(id.agoVar>=0){bs=String(id.agoVar);} else{bs=String(-id.agoVar);}}
if(id.formatVar=='0'){bs=String(id.agoVar);}
if(id.formatVar=='1'){bs=String((float)id.agoVar/10,1);}
if(id.formatVar=='2'){bs=String((float)id.agoVar/100,2);}
if(id.formatVar=='3'){bs=String((float)id.agoVar/1000,3);}
if(id.formatVar=='H'){if(id.modeVar=='B'){bs=String((id.agoVar&0xFF),      HEX); bs.toUpperCase(); uint8_t bl=bs.length(); if(bl==1){bs="0"+bs;}} 
                      if(id.modeVar=='W'){bs=String((id.agoVar&0xFFFF),    HEX); bs.toUpperCase(); uint8_t bl=bs.length(); if(bl==1){bs="000"+bs;} if(bl==2){bs="00"+bs;} if(bl==3){bs=String("0")+bs;}}
                      if(id.modeVar=='L'){bs=String((id.agoVar&0xFFFFFFFF),HEX); bs.toUpperCase(); uint8_t bl=bs.length(); if(bl<8){for(id.idx=0; id.idx<(8-bl);id.idx++){bs=String("0")+bs;}}}} 
if(id.formatVar=='#'){if(id.modeVar=='B'){uint8_t  buff=id.agoVar&0xFF;   for(id.idx=0; id.idx<8;  id.idx++){bs=bs+getSignBit(buff,7-id.idx);}}
                      if(id.modeVar=='W'){uint16_t buff=id.agoVar&0xFFFF; for(id.idx=0; id.idx<16; id.idx++){bs=bs+getSignBit(buff,15-id.idx);}}}
if(id.formatVar=='*'){if(id.modeVar=='B'){uint8_t  buff=id.agoVar&0xFF;   for(id.idx=0; id.idx<8;  id.idx++){bs=bs+getSignBit(buff,id.idx);}}
                      if(id.modeVar=='W'){uint16_t buff=id.agoVar&0xFFFF; for(id.idx=0; id.idx<16; id.idx++){bs=bs+getSignBit(buff,id.idx);}}}
if(id.formatVar=='='){                    uint8_t  buff=id.agoVar&0xF;    for(id.idx=0; id.idx<4;  id.idx++){bs=bs+getSignBit(buff,4-id.idx);}}
if(id.formatVar=='-'){                    uint8_t  buff=id.agoVar&0xF;    for(id.idx=0; id.idx<4;  id.idx++){bs=bs+getSignBit(buff,id.idx);}}											 
for(id.idx=0; id.idx<id.msLenVar; id.idx++){arrWrite(id.num,bs.charAt(id.idx));}
}
//----------------------------------Запись суффикса и End заполнителей-----------------------------
if(id.msLenSuff>0) {arrWrite(id.num,id.suff);}															//--Запись суффикса;
if(id.msLenEnd>0)  {          for(id.idx=0; id.idx<id.msLenEnd;   id.idx++){arrWrite(id.num,' ');}}		//--Запись End-заполнителей; 
//-------------------------------------------------------------------------------------------------
arrReset(id.num);   //--Сброс массива вывода;
}; 	//++++END LcdPreparData()----------------------------------------------------------------------
void LcdPreparStr (RT_HW_LCD44780_PARAM_ID &id, String var){		//++++Подготовка строковой переменной;
arrReset(id.num); 
if(id.cmdRun==3){for(id.idx=0; id.idx<id.len; id.idx++){arrWrite(id.num,' ');} arrReset(id.num); return;}
id.msLenHead=id.msLenVar=id.msLenSuff=0;  													//--Сброс массива вывода и переменных;
id.xSrc=0; if(!(getCharLcdSTR(var,id.xSrc)=='~')){id.msLenVar=getLenSTR(var,id.len);} else{id.msLenVar=0;}		//--Размер переменной; 
id.msLenBegin=getLenBegin(id);	 id.msLenEnd=getLenEnd(id); 													//--Расчет Begin и End;		
if(id.msLenBegin>0){for(id.idx=0; id.idx<id.msLenBegin; id.idx++){arrWrite(id.num,' ');}}						//--Запись Begin-заполнителей; 																																		//--Очистка индекса для getCharLcdPGM();
if(id.msLenVar>0){id.xSrc=0;for(id.idx=0; id.idx<id.msLenVar; id.idx++){arrWrite(id.num,getCharLcdSTR(var,id.xSrc));}}	//--Запись переменной;
if(id.msLenEnd>0)  {for(id.idx=0; id.idx<id.msLenEnd;   id.idx++){arrWrite(id.num,' ');}}						//--Запись End-заполнителей; 
arrReset(id.num);  																								//--Сброс массива вывода;
}; 	//++++END LcdPreparData()----------------------------------------------------------------------
void LcdPreparBar(RT_HW_LCD44780_PARAM_ID &id){		//++++Подготовка строковой переменной;
arrReset(id.num); 
if(id.cmdRun==3){for(id.idx=0; id.idx<id.len; id.idx++){arrWrite(id.num,' ');} arrReset(id.num); return;}
id.msLenHead=0;  							//--Сброс массива вывода и переменных;
if(id.suff=='~') {id.msLenSuff=0;} else{id.msLenSuff=1;}	//--Размер суффикса;
if(id.agoVar>100){id.buff=100;}    else{id.buff=id.agoVar;}	//--Ограничение переменной 100%ж
id.msLenVar=(id.buff*(id.len-id.msLenSuff))/100;			//--Расчет длины линии
id.msLenBegin=getLenBegin(id); 								//--Расчет Begin-заполнителей;	
id.msLenEnd=getLenEnd(id); 									//--Расчет End-заполнителей;																																				//--Очистка индекса для getCharLcdPGM();
if(id.msLenBegin>0){for(id.idx=0; id.idx<id.msLenBegin; id.idx++){arrWrite(id.num,' ');}}			//--Запись Begin-заполнителей;
if(id.msLenVar>0)  {for(id.idx=0; id.idx<id.msLenVar;   id.idx++){arrWrite(id.num,id.formatVar);}}	//--Запись переменной;
if(id.msLenSuff>0) {                                              arrWrite(id.num,id.suff);}		//--Запись суффикса;
if(id.msLenEnd>0)  {for(id.idx=0; id.idx<id.msLenEnd;   id.idx++){arrWrite(id.num,' ');}}			//--Запись End-заполнителей;
arrReset(id.num);  																				    //--Сброс массива вывода;
}; 	//++++END LcdPreparData()----------------------------------------------------------------------
//=================================================================================================
//			         		ОСНОВНАЯ ФУНКЦИЯ ИНИЦИАЛИЗАЦИЯ ВЫВОДА НА LCD
// modeVar: тип данных: B(uint8_t),W(int16_t),L(int32_t),F(float),S(String),C(char),R(бит),T(текст из PROGMEM),G(мерцание);
// formatVar: формат данных: U-целое без знака[B,W,L]; I-целое со знаком[B,W,L], 0,1,2,3-кол-во знаков после точки[0,1,2,3];
// modeTask:  тип вызова задачи -C(по изменению,P(периодически),T(периодически при изменениях),A(по изменениям или периодически),
//                               S(по входу EN 0->1),F(однократно),N(вызов отключен);
// alig: выравнивание в поле:L(влево),C(по центру),R(вправо),N(без вравнивания);
// suff: суффикс(char), выводимый после данных.Если '~' - суффикс не выводится;
// periodLimit: ограничение(ms/tick) по времени вызова задачи[для C,P,T,A];
// periodTask:  период(ms/tick) вызова задач
//=================================================================================================
void initLcdID  (RT_HW_LCD44780_PARAM_ID &id, uint8_t num, char modeVar, char formatVar, char modeTask, char alig, char suff, uint16_t periodLimit, uint16_t periodTask, uint8_t col, uint8_t row, uint8_t len=0){
if( id.custom)		{return;}	//--Выход, если ID уже инициализирован;
if(!checkNum(num))	{return;}	//--Контроль на допустимость номера устройтсаnum;	
id.num=num;						//--Сохранениe номера устройства;
id.modeVar=modeVar;				//--Тип переменной;
id.formatVar=formatVar;			//--Формат переменной;
id.modeTask=modeTask;			//--Тип вызова задачи;
id.alig=alig;					//--Выравнивание в поле;
id.suff=suff;					//--Суффикс;
id.periodGen=ptr[id.num]->periodGen;					//--Период тика;
id.periodTask =timeToTick(periodTask, id.periodGen);	//--Периодичность вывода;
id.periodLimit=timeToTick(periodLimit,id.periodGen);	//--Периодичность вывода;                   
id.periodBlink=timeToTick(        500,id.periodGen);
id.cntBlink=id.modeBlink=id.blink=0;
//----------------------------------------------------------------------------------------------------
if(col>ptr[id.num]->cols) {id.col=ptr[id.num]->cols;} else{id.col=col;}	//--Сохранение номера колонки с ограничением диапазона;
if(row>ptr[id.num]->rows) {id.row=ptr[id.num]->rows;} else{id.row=row;}	//--Сохранение номера строки  с ограничением диапазона;
id.vCursor=pointCursor(id.num,id.col,id.row);                       	//--Сохраняем код управления позицей курсора; 
id.curChip=1; if((ptr[id.num]->chip==2)&&(id.row>2)){id.curChip=2;}		//--Установка номера чипа выводимого поля (для дисплеев 40x4 два чипа);
//----------------------------------------------------------------------------------------------------
id.buff=ptr[id.num]->cols-id.col+1; 									//--Вычисление максимальной длины допустимого поля;
if((len==0)||(len>id.buff)){id.len=id.buff;}		  else{id.len=len;}	//--Установка длины поля;
//----------------------------------------------------------------------------------------------------
id.first=id.flicker=0; 			//--Установка начальных значений;
//-----------------------------------------------------------------------------------------------------
id.custom=1;															//--Установка флага готовности;
};
//=================================================================================================
//			         				ИНИЦИАЛИЗАЦИЯ ВЫВОДА НА LCD
//=================================================================================================
void initBlinkID(RT_HW_LCD44780_PARAM_ID &id,uint8_t n,                                      uint16_t pTsk,uint8_t col,uint8_t row){initLcdID(id,n,'F','N','P','N','~', 50,pTsk,col,row);};	
void initBitID  (RT_HW_LCD44780_PARAM_ID &id,uint8_t n,                                      uint8_t col,uint8_t row)              {initLcdID(id,n,'R','N','C','L','~', 50,2500,col,row);};	
void initCharID (RT_HW_LCD44780_PARAM_ID &id,uint8_t n,                                      uint8_t col,uint8_t row)              {initLcdID(id,n,'L','N','C','N','~',100,2500,col,row);};	
void initTextID (RT_HW_LCD44780_PARAM_ID &id,uint8_t n,         char alg,                    uint8_t col,uint8_t row,uint8_t len=0){initLcdID(id,n,'T','N','C',alg,'~',500,2500,col,row,len);};			
void initByteID (RT_HW_LCD44780_PARAM_ID &id,uint8_t n,char frm,char alg,char sff,           uint8_t col,uint8_t row,uint8_t len=0){initLcdID(id,n,'B',frm,'C',alg,sff,100,2500,col,row,len);}
void initWordID (RT_HW_LCD44780_PARAM_ID &id,uint8_t n,char frm,char alg,char sff,           uint8_t col,uint8_t row,uint8_t len=0){initLcdID(id,n,'W',frm,'C',alg,sff,200,2500,col,row,len);}
void initLongID (RT_HW_LCD44780_PARAM_ID &id,uint8_t n,char frm,char alg,char sff,           uint8_t col,uint8_t row,uint8_t len=0){initLcdID(id,n,'L',frm,'C',alg,sff,250,2500,col,row,len);}
void initFloatID(RT_HW_LCD44780_PARAM_ID &id,uint8_t n,char frm,char alg,char sff,           uint8_t col,uint8_t row,uint8_t len=0){initLcdID(id,n,'F',frm,'C',alg,sff,500,2500,col,row,len);}		 
void initStrID  (RT_HW_LCD44780_PARAM_ID &id,uint8_t n,         char alg,                    uint8_t col,uint8_t row,uint8_t len=0){initLcdID(id,n,'S','N','C',alg,'~',500,5000,col,row,len);}	
void initBarID  (RT_HW_LCD44780_PARAM_ID &id,uint8_t n,char frm,char alg,char sff,           uint8_t col,uint8_t row,uint8_t len=0){initLcdID(id,n,'X',frm,'C',alg,sff,100,5000,col,row,len);}	
//=================================================================================================
//						       			ВЫВОД ПЕРЕМЕННЫХ
//=================================================================================================
void LcdBlink(RT_HW_LCD44780_PARAM_ID &id,              char sign0=' ', char sign1='*'){	//++++Мерцание символом;
LcdGenerator(id);  //++++Генератор, возвращает id.run: 0-ожидание; =1-безусловный вывод; =2-вывод по изменению var; =3 очистка поля; 
if(id.dir==0) {if(id.run==0){return;} if(!id.custom){return;} id.cmdRun=id.run; id.dir++;} //--Ожидание разрешения на вывод;
if(id.dir==1) {if(!getBusy(id.num)){return;} 					id.dir=30; 	//--Указатель на выход;
			   if(id.cmdRun==3){id.buff=RT_HW_LCD44780_BLANK; 	id.dir=20;}	//--Переход на очистку поля;
			   if(id.cmdRun==1){             					id.dir=10;}	//--Безусловный вывод;
			   if(id.dir==1)   {		 						id.dir=30;} //--Переход на завершение;
			   id.cmdRun=0;}												//--Сброс cmdRun перед переходом;
//---------------------------Подготовка выводимых данных-------------------------------------------												
if(id.dir==10){if(id.agoBit){id.buff=sign1;} else{id.buff=sign0;} id.agoBit=!id.agoBit; id.dir=20;}	
//-----------------------------------Вывод на LCD--------------------------------------------------	
if(id.dir==20){if(!deviceSend(id.num,id.curChip,id.vCursor,'I',50)){return;} id.dir++;}	//--Установка курсора  с задержкой 50mcs; 
if(id.dir==21){if(!deviceSend(id.num,id.curChip,id.buff,'D'))      {return;} id.dir=30;}//--Вывод символа;	
//-----------------------------------Завершение----------------------------------------------------
if(id.dir==30){clearBusy(id.num); id.run=0; id.dir=0; return;} //--Освобождение шины и переход на начало;
};	//====END void LcdSign()=======================================================================
void LcdBit  (RT_HW_LCD44780_PARAM_ID &id, uint8_t var, char sign0='-', char sign1='+'){	//++++Вывод битовой переменной;
LcdGenerator(id);  //++++Генератор, возвращает id.run: 0-ожидание; =1-безусловный вывод; =2-вывод по изменению var; =3 очистка поля; 
if(id.dir==0) {if(id.run==0){return;} if(!id.custom){return;} id.cmdRun=id.run; id.dir++;} //--Ожидание разрешения на вывод;
if(id.dir==1) {if(!getBusy(id.num)){return;} 					id.dir=30; 	//--Указатель на выход;
			   if(id.cmdRun==3){id.buff=RT_HW_LCD44780_BLANK; 	id.dir=20;} //--Переход на очистку поля;
			   if(id.cmdRun==1){            		            id.dir=10;} //--Безусловный вывод;
               if(id.cmdRun==2){if(id.agoBit!=var){             id.dir=10;}}//-Безусловный вывод;			   
			   if(id.dir==1)   {		 						id.dir=30;} //--Переход на завершение;
			   id.cmdRun=0;}												//--Сброс cmdRun перед переходом;
//---------------------------Подготовка выводимых данных-------------------------------------------												
if(id.dir==10){id.agoBit=var; if(id.agoBit==0){id.buff=sign0;} else{id.buff=sign1;} id.dir=20;}	
//-----------------------------------Вывод на LCD--------------------------------------------------	
if(id.dir==20){if(!deviceSend(id.num,id.curChip,id.vCursor,'I',50)){return;} id.dir++;}	//--Установка курсора  с задержкой 50mcs; 
if(id.dir==21){if(!deviceSend(id.num,id.curChip,id.buff,'D'))      {return;} id.dir=30;}//--Вывод символа;	
//-----------------------------------Завершение----------------------------------------------------
if(id.dir==30){clearBusy(id.num); id.run=0; id.dir=0; return;} //--Освобождение шины и переход на начало;
};	//====END void LcdSign()=======================================================================
void LcdChar (RT_HW_LCD44780_PARAM_ID &id, char    var){									//++++Вывод символьной переменной;
LcdGenerator(id);  //++++Генератор, возвращает id.run: 0-ожидание; =1-безусловный вывод; =2-вывод по изменению var; =3 очистка поля; 
if(id.dir==0) {if(id.run==0){return;} if(!id.custom){return;} id.cmdRun=id.run; id.dir++;} //--Ожидание разрешения на вывод;
if(id.dir==1) {if(!getBusy(id.num)){return;} 					id.dir=30; 	//--Указатель на выход;
			   if(id.cmdRun==3){id.buff=RT_HW_LCD44780_BLANK; 	id.dir=20;}	//--Переход на очистку поля;
			   if(id.cmdRun==1){                   				id.dir=10;} //--Безусловный вывод;
			   if(id.cmdRun==2){if(id.agoVar!=var){			 	id.dir=10;}}//--Вывод по изменениям;
			   if(id.dir==1)   {		 						id.dir=30;} //--Переход на завершение;	
			   id.cmdRun=0;}												//--Сброс cmdRun перед переходом;			   
//---------------------------Подготовка выводимых данных-------------------------------------------												
if(id.dir==10){id.agoVar=var; id.dir=20;}	
//-----------------------------------Вывод на LCD--------------------------------------------------	
if(id.dir==20){if(!deviceSend(id.num,id.curChip,id.vCursor,'I',50)){return;} id.dir++;}	//--Установка курсора  с задержкой 50mcs; 
if(id.dir==21){if(!deviceSend(id.num,id.curChip,(uint8_t)id.agoVar,'D'))      {return;} id.dir=30;}//--Вывод символа;	
//-----------------------------------Завершение----------------------------------------------------
if(id.dir==30){clearBusy(id.num); id.run=0; id.dir=0; return;} //--Освобождение шины и переход на начало;
};	//====END void LcdSign()=======================================================================
void LcdText (RT_HW_LCD44780_PARAM_ID &id, const char *head){ 								//++++Вывод фиксированного текста;
LcdGenerator(id);  //++++Генератор, возвращает id.run: 0-ожидание; =1-безусловный вывод; =2-вывод по изменению var; =3 очистка поля; 
if(id.dir==0) {if(id.run==0){return;} if(!id.custom){return;} id.cmdRun=id.run; id.dir++;} 	//--Ожидание разрешения на вывод;
if(id.dir==1) {if(!getBusy(id.num)){return;} 							  id.dir=30;  //--Указатель на выход;
			   if(id.cmdRun==3){arrInit(id.num,id.len); arrClear(id.num); id.dir=20;} //--Переход на очистку поля;
			   if(id.cmdRun==1){arrInit(id.num,id.len);             	  id.dir=10;} //--Безусловный вывод;
			   if(id.dir==1)   {		 								  id.dir=30;} //--Переход на завершение;	
			   id.cmdRun=0;}														  //--Сброс cmdRun перед переходом;	
if(id.dir==10){LcdPreparData(id,head);                                    id.dir=20;} //--Запись выводимых данных в массив;
if(id.dir==20){if(!(arrSend(id.num,id.curChip,id.vCursor))){return;}      id.dir=30;} //--Вывод на Lcd;
if(id.dir==30){clearBusy(id.num); id.run=0;                               id.dir=0; return;} //--Освобождение шины и переход на начало;
};	//====END void LcdText()=======================================================================
void LcdVar  (RT_HW_LCD44780_PARAM_ID &id, const char *head, int32_t var){	                //++++Вывод v8,v16,v32(mode=U,I,H,1,2,3,#,*);
LcdGenerator(id);  //++++Генератор, возвращает id.run: 0-ожидание; =1-безусловный вывод; =2-вывод по изменению var; =3 очистка поля; 
if(id.dir==0) {if(id.run==0){return;} if(!id.custom){return;} id.cmdRun=id.run; id.dir++;} 		//==Ожидание разрешения на вывод;
if(id.dir==1) {if(!getBusy(id.num)){return;} id.dir=30;   										//==Захват шины, переход на обработку с сохранение var;
               if(id.cmdRun==3){arrInit(id.num,id.len); arrClear(id.num); id.dir=10;}  //--Переход на очистку поля;		   
               if(id.cmdRun==1){arrInit(id.num,id.len); id.agoVar=var;    id.dir=10;}  //--Безусловный вывод;
               if(id.cmdRun==2){if(id.agoVar!=var){id.agoVar=var; arrInit(id.num,id.len); id.dir=10;}}//--Обработка изменений;
			   if(id.dir==1)   {		 								  id.dir=30;} //--Переход на завершение;	
			   id.cmdRun=0;}														  //--Сброс cmdRun перед переходом;	
if(id.dir==10){LcdPreparData(id,head);  							      id.dir=20; return;}	//--Запись выводимых данных в массив;
if(id.dir==20){if(!(arrSend(id.num,id.curChip,id.vCursor))){return;}      id.dir=30;} //--Вывод на Lcd;
if(id.dir==30){clearBusy(id.num);       id.run=0; id.dir=0; return;} 									//--Освобождение шины и переход на начало;
};	//====END void LcdVar()========================================================================
void LcdFloat(RT_HW_LCD44780_PARAM_ID &id, const char *head, float var){	                //++++Вывод float(mode=1,2,3);
LcdGenerator(id);  //++++Генератор, возвращает id.run: 0-ожидание; =1-безусловный вывод; =2-вывод по изменению var; =3 очистка поля; 
if(id.dir==0) {if(id.run==0){return;} if(!id.custom){return;} id.cmdRun=id.run; id.dir++;} 		//==Ожидание разрешения на вывод;
if(id.dir==1) {if(!getBusy(id.num)){return;} id.dir=30;   										//==Захват шины, переход на обработку с сохранение var;
               if(id.cmdRun==3){arrInit(id.num,id.len); arrClear(id.num); id.dir=20;}; 			//--Переход на очистку поля;		   
               if(id.cmdRun==1){arrInit(id.num,id.len); id.agoVar=floatToInt(id.formatVar,var); id.dir=10;}  			//--Безусловный вывод;
               if(id.cmdRun==2){if(id.agoVar!=floatToInt(id.formatVar,var)){
				                arrInit(id.num,id.len); id.agoVar=floatToInt(id.formatVar,var); id.dir=10;}}//--Обработка изменений;
			   if(id.dir==1)   {		 								  id.dir=30;} //--Переход на завершение;	
			   id.cmdRun=0;}														  //--Сброс cmdRun перед переходом;									
if(id.dir==10){LcdPreparData(id,head);  							      id.dir=20; return;}	//--Запись выводимых данных в массив;
if(id.dir==20){if(!(arrSend(id.num,id.curChip,id.vCursor))){return;}      id.dir=30;}			//--Вывод на Lcd;
if(id.dir==30){clearBusy(id.num);       id.run=0; id.dir=0; return;} 									//--Освобождение шины и переход на начало;
};	//====END void LcdVar()========================================================================
void LcdStr  (RT_HW_LCD44780_PARAM_ID &id, String &agoVar,  String var){					//++++Вывод String;
LcdGenerator(id);  //++++Генератор, возвращает id.run: 0-ожидание; =1-безусловный вывод; =2-вывод по изменению var; =3 очистка поля; 
if(id.dir==0) {if(id.run==0){return;} if(!id.custom){return;} id.cmdRun=id.run; id.dir++;} 	//==Ожидание разрешения на вывод;
if(id.dir==1) {if(!getBusy(id.num)){return;} id.dir=30;   									//==Захват шины, переход на обработку с сохранение var;
               if(id.cmdRun==3){                arrInit(id.num,id.len); arrClear(id.num); id.dir=20;}; //--Переход на очистку поля;		   
               if(id.cmdRun==1){                arrInit(id.num,id.len); agoVar=var;       id.dir=10;}  //--Безусловный вывод;
               if(id.cmdRun==2){if(agoVar!=var){arrInit(id.num,id.len); agoVar=var;       id.dir=10;}} //--Обработка изменений;
			   if(id.dir==1)   {		 								  				  id.dir=30;}  //--Переход на завершение;	
			   id.cmdRun=0;}														  				   //--Сброс cmdRun перед переходом;	
if(id.dir==10){LcdPreparStr(id,var);  							                          id.dir=20; return;}//==Запись выводимых данных в массив;
if(id.dir==20){if(!(arrSend(id.num,id.curChip,id.vCursor))){return;}                      id.dir=30;}	//==Вывод на Lcd;
if(id.dir==30){clearBusy(id.num);       id.run=0; id.dir=0; return;} 									//==Освобождение шины и переход на начало;
};	//====END void LcdVar()========================================================================
void LcdBar  (RT_HW_LCD44780_PARAM_ID &id,                 int32_t var){	                //++++Вывод v8,v16,v32(mode=U,I,H,1,2,3,#,*);
LcdGenerator(id);  //++++Генератор, возвращает id.run: 0-ожидание; =1-безусловный вывод; =2-вывод по изменению var; =3 очистка поля; 
if(id.dir==0) {if(id.run==0){return;} if(!id.custom){return;} id.cmdRun=id.run; id.dir++;} 		//==Ожидание разрешения на вывод;
if(id.dir==1) {if(!getBusy(id.num)){return;} id.dir=30;   										//==Захват шины, переход на обработку с сохранение var;
               if(id.cmdRun==3){arrInit(id.num,id.len); arrClear(id.num); id.dir=20;}; 			//--Переход на очистку поля;		   
               if(id.cmdRun==1){arrInit(id.num,id.len); id.agoVar=var;    id.dir=10;}  			//--Безусловный вывод;
               if(id.cmdRun==2){if(id.agoVar!=var){id.agoVar=var;arrInit(id.num,id.len); id.dir=10;}}//--Обработка изменений;
			   if(id.dir==1)   {		 								  id.dir=30;} //--Переход на завершение;	
			   id.cmdRun=0;}														  //--Сброс cmdRun перед переходом;	
if(id.dir==10){LcdPreparBar(id);  							      		  id.dir=20; return;}	//--Запись выводимых данных в массив;
if(id.dir==20){if(!(arrSend(id.num,id.curChip,id.vCursor))){return;}      id.dir=30;}			//--Вывод на Lcd;
if(id.dir==30){clearBusy(id.num);       id.run=0; id.dir=0; return;} 									//--Освобождение шины и переход на начало;
};	//====END void LcdVar()========================================================================
void LcdVAR  (RT_HW_LCD44780_PARAM_ID &id, int32_t var){LcdVar  (id,RT_HW_LCD44780_HEAD,var);};//++Вывод v8,v16,v32 без заголовка;
void LcdFLOAT(RT_HW_LCD44780_PARAM_ID &id, float   var){LcdFloat(id,RT_HW_LCD44780_HEAD,var);};//++Вывод float(mode=1,2,3) без заголовка;
//=================================================================================================
//=================================================================================================
//						              		УТИЛИТЫ
//=================================================================================================
int32_t floatToInt(char formatVar, float var) { 	     //++++Конвертация float в int32_t----------------
 if(formatVar=='-') {return (int32_t)(var);}	
 if(formatVar=='1') {return (int32_t)(var*10);}	
 if(formatVar=='2') {return (int32_t)(var*100);}
 if(formatVar=='3') {return (int32_t)(var*1000);}	
                     return (int32_t)(var);
};	//++++END LcdFloatInt()========================================================================
uint8_t convert   (uint8_t charH, uint8_t charL){		 //++++Возвращает номер символа из  utf-8---------
if(charH==0xD0) {if (charL==0x81) {return 0x40;}  if((charL>=0x90) && (charL<=0xBF)){return (charL-0x90);}};
if(charH==0xD1) {if (charL==0x91) {return 0x41;}  if((charL>=0x80) && (charL<=0x8F)){return (charL-0x50);}}; return charL;}; 
uint8_t pointCursor(uint8_t num, uint8_t vCol, uint8_t vRow){ //++++Вычисление адреса курсора-------------
uint8_t cols=ptr[num]->cols;		//--Установка кол-во колонок;
uint8_t rows=ptr[num]->rows;		//--Установка кол-во строk
uint8_t row=vRow;
uint8_t col=vCol;
//if(row>rows){row=rows;}; if(row<1) {row=1;} row--;
//if(col>cols){col=cols;}; if(col<1) {col=1;} col--;
row=constrain(row,1,rows)-1;
col=constrain(col,1,cols)-1;
uint8_t adr=0; 
//-------------------------------------------------------------------------------------------------
if(ptr[num]->cols==16){if(ptr[num]->rows==1){if(col<=8) {adr=col;} else {adr=8+col;}}
				  else{uint8_t row_offsets[] = {0x00,0x40,0x10,0x50}; adr=col+row_offsets[row];}}  	
if(ptr[num]->cols==20){uint8_t row_offsets[] = {0x00,0x40,0x14,0x54}; adr=col+row_offsets[row];}   	
if(ptr[num]->cols==40){uint8_t row_offsets[] = {0x00,0x40,0x00,0x40}; adr=col+row_offsets[row];}             
//-------------------------------------------------------------------------------------------------
bitSet(adr,7); 
//-------------------------------------------------------------------------------------------------
return adr;}
uint8_t getLenBegin(RT_HW_LCD44780_PARAM_ID &id){        //++++Begin.Blank--------------------------------
id.buff=id.msLenHead+id.msLenVar+id.msLenSuff;
if(id.len<=id.buff){return 0;} if(id.alig=='C'){return(id.len-id.buff-(id.len-id.buff)/2);} 
                               if(id.alig=='R'){return(id.len-id.buff);} return 0;};  
uint8_t getLenEnd  (RT_HW_LCD44780_PARAM_ID &id){        //++++End.Blank----------------------------------
id.buff=id.msLenHead+id.msLenVar+id.msLenSuff;
if(id.len<=id.buff){return 0;} if(id.alig=='C'){return(id.len-id.buff-getLenBegin(id));} 
                               if(id.alig=='L'){return(id.len-id.buff);} return 0;};  
uint8_t getCodeCharLcdPGM(uint8_t code){                 //++++Возвращает код   символа из PROGMEM utf-8 в коды lcd;
	return pgm_read_byte(RT_HW_LCD44780_CONVERT_RUS+code);};
uint8_t getLenSTR(String &str,     uint8_t lenMax){      //++++Возвращает длину текста из String (utf-8);							
uint8_t buff,j,len; if(lenMax==0) {lenMax=80;} j=len=0;
while (1) {buff=str[j];	         if(buff>=0xC0) {j++; buff=str[j];}  j++;	
           if((buff==0) || (buff==RT_HW_BREAK_CHAR) || (len>lenMax) || (j>160)) {break;} 
		   if(buff>=0xC0) {j++;} //buff=str(j);
		   len++;} 		   
		   //len++;} 
return len;}
uint8_t getLenPGM(const char *text,uint8_t lenMax){	     //++++Возвращает длину текста из PROGMEM(utf-8);
	uint8_t buff,j,len; if(lenMax==0) {lenMax=80;} j=len=0;
while (1) {buff=pgm_read_byte(text+j);	j++;
		   if((buff==0) || (buff==RT_HW_BREAK_CHAR) || (len>lenMax) || (j>160)) {break;}
		   if(buff>=0xC0) {j++;} //buff=pgm_read_byte(text+j);
		   len++;} 
return len;}
uint8_t getCharLcdSTR(String str,       uint8_t &xSrc){  //++++Возвращает следующий   код String (utf-8) в формате lcd;						
uint8_t buff1=str[xSrc]; uint8_t buff2=0; xSrc++; 
if(buff1>=0xC0){buff2=str[xSrc]; xSrc++; return getCodeCharLcdPGM(convert(buff1,buff2));} else {return buff1;}}
uint8_t getCharLcdPGM(const char *text, uint8_t &xSrc){	 //++++Возвращает следующий   код PROGMEM(utf-8) в формате lcd;
uint8_t buff1=pgm_read_byte(text+xSrc);; uint8_t buff2=0; xSrc++;
if(buff1>=0xC0) {buff2=pgm_read_byte(text+xSrc); xSrc++; return getCodeCharLcdPGM(convert(buff1,buff2));} 
else            {return buff1;}}
String  getSignBit    (uint16_t var, uint8_t idx){if(bitRead(var,idx)) {return String("+");} else {return String("-");}} 
char    getSignBitCode(uint8_t code, uint8_t v){		 //++++Возвращает по номеру code табличный символ для отображения бита;	
if(v){return (char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_1,code);} 
else {return (char)RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_0,code);}};
//=================================================================================================
