//============================Объекты и переменные Lcd.1=============================================
RT_HW_LCD44780_DEVICE_ID z1; uint8_t n1;                                  //--Объект управления LCD;
RT_HW_LCD44780_PARAM_ID  z1Blink, z1BTN, z1speed;                         //--Объекты для вывода blink,кнопки,быстродействие;
RT_HW_LCD44780_PARAM_ID  z1ADC;                        const char z1hADC[]  PROGMEM="a=";   
RT_HW_LCD44780_PARAM_ID  z1MAX,z1max, z1MAXOk,z1maxOk; const char z1hMAX[]  PROGMEM="M=";   const char z1hmax[]   PROGMEM="m=";
//=====================================================================================================
//                                         LCD1
//=====================================================================================================
void Lcd1(){
//--------------------------------------------------------------------------------------
if(z1.custom==0){RT_HW_lcd44780.initDeviceI2CPCF8574(z1,16,2,39,0,400000UL);} RT_HW_lcd44780.directDevice(z1); n1=z1.num;
//--------------------------------------------------------------------------------------
if(z1Blink.custom==0){RT_HW_lcd44780.initBlinkID (z1Blink,n1,500, 1,1);}           RT_HW_lcd44780.LcdBlink(z1Blink,' ','*');          //--Мерцающий символ;
if(z1BTN.custom==0)  {RT_HW_lcd44780.initBitID   (z1BTN,  n1,     2,1);}           RT_HW_lcd44780.LcdBit (z1BTN,vChatBut,'-','+');    //--Вывод кнопки;;
if(z1ADC.custom==0)  {RT_HW_lcd44780.initWordID  (z1ADC,  n1,'U','L',';', 3,1,4);} RT_HW_lcd44780.LcdVAR (z1ADC,vADCF);               //--Вывод ADC(без заголовка);
if(z1speed.custom==0){RT_HW_lcd44780.initWordID  (z1speed,n1,'U','R','~',14,1,0);} RT_HW_lcd44780.LcdVAR(z1speed,vSpeedSmall);        //--Вывод скорости(без заголовка);
//--------------------------------------------------------------------------------------
if(z1MAXOk.custom==0){RT_HW_lcd44780.initBitID   (z1MAXOk,n1,1,2);}                RT_HW_lcd44780.LcdBit  (z1MAXOk,     spiMAX6675ok,'-','+'); //--Вывод ok сенсора;
if(z1MAX.custom==0)  {RT_HW_lcd44780.initFloatID (z1MAX, n1,'2','L',';', 2,2,8);}  RT_HW_lcd44780.LcdFloat(z1MAX,z1hMAX,spiMAX6675temp);       //--Вывод температуры MAX6676.SPI;
if(z1maxOk.custom==0){RT_HW_lcd44780.initBitID   (z1maxOk,n1,10,2);}               RT_HW_lcd44780.LcdBit  (z1maxOk,     spnMAX6675ok,'-','+'); //--Вывод ok сенсора;
if(z1max.custom==0)  {RT_HW_lcd44780.initFloatID (z1max, n1,'2','L',';',11,2,0);}  RT_HW_lcd44780.LcdFLOAT(z1max,       spnMAX6675temp);       //--Вывод температуры max6676.SPN;
//--------------------------------------------------------------------------------------
};
//=====================================================================================================
