//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                           Вывод на LCD HD44780 мерцающего символа;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#include "RT_HW_EXTENDERS.h"
//=================================================================================================
RT_HW_PIN_DIR_ID idPinControl, idPinDebug; //--
RT_HW_MCP23x17 z; 
RT_HW_STRUCT_SHED_TASK idIn,idOut;
RT_HW_GENERATOR_EVENT_ID idGenA;  RT_HW_COUNTER_ID idCntA;  uint8_t  genA=0;  //--Для генератора бегущей "1"; 
RT_HW_GENERATOR_EVENT_ID idGenB;  RT_HW_COUNTER_ID idCntB;  uint8_t  genB=0;  //--Для генератора бегущей "1"; 
bool vControl;
//=================================================================================================
uint8_t agoDDR=255;
uint8_t agoStep=255;
void testDir(){
if((agoDDR!=z.ddr)||(agoStep!=z.step)){
agoDDR=z.ddr; agoStep=z.step; 
RT_HW_Base.consoleTest(String(F("MCP23017 initDevice")),z.initDevice,';');
RT_HW_Base.consoleTest(String(F(" ddr")),z.ddr,';');
RT_HW_Base.consoleTest(String(F(" step")),z.step,';');
RT_HW_Base.consoleTest(String(F(" pointDelay")),z.pointDelay,';');
RT_HW_Base.consoleTest(String(F(" sizeDelay")),z.sizeDelay,';');
RT_HW_Base.consoleTest(String(F(" codeErr")),z.codeErr,'E');
}}
//=================================================================================================
void setup() {}
//=================================================================================================
void loop() {
RT_HW_Base.consoleBegin();
//------------------------------------------------------------------------------------------------
if(RT_HW_Base.console.head){
  RT_HW_Base.consoleHead(String(F("Main parameters")));  RT_HW_Base.consoleBoardGeneral();           
  RT_HW_Base.consoleHead(String(F("System pins")));      RT_HW_Base.consolePinsSystem();  
  RT_HW_Base.consoleHead(String(F("Interface")));        RT_HW_Base.consoleInterface(); 
  RT_HW_Base.consoleHead(String(F("Scan i2c")));         RT_HW_Base.i2cScanBus(0);   
  RT_HW_Base.consoleLine('+');}
//------------------------------------------------------------------------------------------------
vControl=!vControl;
RT_HW_Base.pinDigitalWrite(idPinControl,RT_HW_Base.device.pin.control,vControl);    //--Вывод loop() на контрольный пин;
RT_HW_Base.pinDigitalWrite(idPinDebug,  RT_HW_Base.device.pin.debug1, z.runOut);    //--Вывод loop() на контрольный пин;

//------------------------------------------------------------------------------------------------
//-----------------------------Генератор бегущей единицы 1-8, пила 100ms -------------------------
if(idCntA.reset){RT_HW_Base.counterReset  (idCntA,4,0,1,0);}   //--init счетчика:верхняя(Top=8) граница, нижняя граница(Buttom=0),шаг изменения(Step=1); нач.знач.(Begin=0);
if(idCntB.reset){RT_HW_Base.counterReset  (idCntB,8,0,1,0);}   //--init счетчика:верхняя(Top=8) граница, нижняя граница(Buttom=0),шаг изменения(Step=1); нач.знач.(Begin=0);
if(RT_HW_Base.generatorEvent(idGenA,100)){genA=RT_HW_Base.counterS(idCntA); genA=RT_HW_Base.dc8(genA); z.extA=genA;} 
if(RT_HW_Base.generatorEvent(idGenB,100)){genB=RT_HW_Base.counterT(idCntB); genB=RT_HW_Base.dc8(genB); z.extB=genB;}  
//z.extA=0x55;
//z.extB=0xAA;
//-------------------------------------------------------------------------------------------------
if(idIn.custom==0) {RT_HW_Base.setTaskID(idIn,'P',100,500,50);}
if(idOut.custom==0){RT_HW_Base.setTaskID(idOut,'A',50,500,50);}
if(z.custom==0){z.cnfgA=0xF0; z.cnfgIPOLA=0xFF; z.cnfgGPPUA=0xFF;
                z.cnfgB=0x00; z.cnfgIPOLB=0xFF; z.cnfgGPPUB=0xFF;
                z.adr=0x20; z.bus=0; z.speed=0;
                z.custom=1;}    
z.runIn= RT_HW_Base.directTask(idIn);                 
z.runOut=RT_HW_Base.directTask(idOut);                
z.direct();                                             //--Управление сенсором;
if(z.fresh==2){z.fresh=0;
  RT_HW_Base.consoleTest(String(F("INA")),z.inA,';','H');
  RT_HW_Base.consoleTest(String(F(" INB")),z.inB,'E','H');
  }
//-------------------------------------------------------------------------------------------------
//testDir();
//-------------------------------------------------------------------------------------------------
} //+++++END loop()================================================================================
//-------------------------------------------------------------------------------------------------
