//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//     			 БИБЛИОТЕКА RT_HW_SPI_HC595
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  ecoins (ecoins@mail.ru) 
//  2022-22-18: Begin version
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-------------------------------------------------------------------------------------------------
#ifndef RT_HW_SPI_HC165_h
#define RT_HW_SPI_HC165_h
#define RT_HW_SPI_HC1655_VER 10	//--Номер версии библиотеки;
#include "RT_HW_BASE.h"			//--Подключение базовой библиотеки;
/*
if(id.dir==0) {RT_HW_Base.SPIinitDevice(codeErr,cs, Шина SPI (0,1,2) ); id.dir=10;}
if(id.dir==10){RT_HW_Base.FLProgCheckEvent(id,timeBegin, Режим ввода , Период ввода );   if(id.state>=1){id.dir=20;}}
if(id.dir==20){
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs);	uint8_t in[4];
RT_HW_Base.spiBeginTransaction( Частота шины Гц , Порядок следования битов ,0, Шина SPI (0,1,2) );		
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS);
in[0]=RT_HW_Base.spiRead( Шина SPI (0,1,2) );   
in[1]=RT_HW_Base.spiRead( Шина SPI (0,1,2) );   
in[2]=RT_HW_Base.spiRead( Шина SPI (0,1,2) );   
in[3]=RT_HW_Base.spiRead( Шина SPI (0,1,2) );   
RT_HW_Base.spiEndTransaction( Шина SPI (0,1,2) );
if( Инверсия выходного значения) {in[0]=in[0]^0xFF;  in[1]=in[1]^0xFF; in[2]=in[2]^0xFF;  in[3]=in[3]^0xFF;}
v32=((uint32_t)in[3] <<24)  |  ((uint32_t)in[2] <<16) |  ((uint32_t)in[1] <<8) | in[0];
id.dir=10;} 
*/
//=================================================================================================
class RT_HW_SPIhc165  {		//+++++КЛАСС УПРАВЛЕНИЯ RT_HW_SPIhc165=================================
public:
uint8_t  custom=0, run=0, cmdRun=1, ddr=0, initDevice=0, codeErr;  uint8_t fresh=0;
uint8_t  inv=0, bitOrder=1, cs=255; uint8_t bus=0; uint32_t speed=0;
uint8_t  var;
//-------------------------------------------------------------------------------------------------
void setParam(uint8_t _inv, uint8_t _bitOrder, uint8_t _cs, uint8_t _bus=0, uint32_t _speed=0){//++++Установка параметров;
inv=_inv; bitOrder=_bitOrder; cs=_cs; bus=_bus; speed=_speed; custom=1;};	
void direct(){
//-------------------------------------------------------------------------------------------------
if(ddr== 0){if(custom!=1){return;} initDevice=0; ddr=10;}	//--Инициализация;
if(ddr==10){if(!run){return;} if(!initDevice){ddr=20;} else{ddr=30;}}	//--Выбор продолжения;
//-------------------------------------------------------------------------------------------------
if(ddr==20){	
if(!RT_HW_Base.SPIinitDevice(codeErr,cs,bus)){return;}  //--Инициализация шины с проверкой CS;
if(codeErr){ddr=10; codeErr=80; return;} else{initDevice=1; ddr=30;}} 
//-------------------------------------------------------------------------------------------------
if(ddr==30){
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs);	
RT_HW_Base.spiBeginTransaction(speed, bitOrder,0,bus);		
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS);
var=RT_HW_Base.spiRead(bus);
RT_HW_Base.spiEndTransaction(bus);
if(inv){var=var^0xFF;}
fresh=1; ddr=10;}}//--Ввод через SPI;
};	//++++END class RT_HW_SPIhc165================================================================
class RT_HW_SPIhc165x2{		//+++++КЛАСС УПРАВЛЕНИЯ RT_HW_SPIhc165x2===============================
public:
uint8_t  custom=0, run=0, cmdRun=1, ddr=0, initDevice=0, codeErr;  uint8_t fresh=0;
uint8_t  inv=0, bitOrder=1, cs=255; uint8_t bus=0; uint32_t speed=0;
uint16_t var;
//-------------------------------------------------------------------------------------------------
void setParam(uint8_t _inv, uint8_t _bitOrder, uint8_t _cs, uint8_t _bus=0, uint32_t _speed=0){//++++Установка параметров;
inv=_inv; bitOrder=_bitOrder; cs=_cs; bus=_bus; speed=_speed; custom=1;};	
void direct(){
//-------------------------------------------------------------------------------------------------
if(ddr== 0){if(custom!=1){return;} initDevice=0; ddr=10;}	//--Инициализация;
if(ddr==10){if(!run){return;} if(!initDevice){ddr=20;} else{ddr=30;}}	//--Выбор продолжения;
//-------------------------------------------------------------------------------------------------
if(ddr==20){	
if(!RT_HW_Base.SPIinitDevice(codeErr,cs,bus)){return;}  //--Инициализация шины с проверкой CS;
if(codeErr){ddr=10; codeErr=80; return;} else{initDevice=1; ddr=30;}} 
//-------------------------------------------------------------------------------------------------
if(ddr==30){
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs);	
RT_HW_Base.spiBeginTransaction(speed, bitOrder,0,bus);		
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS);
var=(uint16_t)RT_HW_Base.spiRead(bus)<<8; var=var+(uint8_t)RT_HW_Base.spiRead(bus);
RT_HW_Base.spiEndTransaction(bus);
if(inv){var=var^0xFFFF;}
ddr=10;}}//--Ввод через SPI;
};	//++++END class RT_HW_SPIhc165x2===============================================================
class RT_HW_SPIhc165x3{		//+++++КЛАСС УПРАВЛЕНИЯ RT_HW_SPIhc165x3===============================
public:
uint8_t  custom=0, run=0, cmdRun=1, ddr=0, initDevice=0, codeErr;  uint8_t fresh=0;
uint8_t  inv=0, bitOrder=1, cs=255; uint8_t bus=0; uint32_t speed=0;
uint32_t var;
//-------------------------------------------------------------------------------------------------
void setParam(uint8_t _inv, uint8_t _bitOrder, uint8_t _cs, uint8_t _bus=0, uint32_t _speed=0){//++++Установка параметров;
inv=_inv; bitOrder=_bitOrder; cs=_cs; bus=_bus; speed=_speed; custom=1;};	
void direct(){
//-------------------------------------------------------------------------------------------------
if(ddr== 0){if(custom!=1){return;} initDevice=0; ddr=10;}	//--Инициализация;
if(ddr==10){if(!run){return;} if(!initDevice){ddr=20;} else{ddr=30;}}	//--Выбор продолжения;
//-------------------------------------------------------------------------------------------------
if(ddr==20){	
if(!RT_HW_Base.SPIinitDevice(codeErr,cs,bus)){return;}  //--Инициализация шины с проверкой CS;
if(codeErr){ddr=10; codeErr=80; return;} else{initDevice=1; ddr=30;}} 
//-------------------------------------------------------------------------------------------------
if(ddr==30){
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs);	
RT_HW_Base.spiBeginTransaction(speed, bitOrder,0,bus);		
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS);
var=(uint32_t)RT_HW_Base.spiRead(bus)<<16; var=var+(((uint32_t)RT_HW_Base.spiRead(bus))<<8); var=var+(uint8_t)RT_HW_Base.spiRead(bus);
RT_HW_Base.spiEndTransaction(bus);
if(inv){var=var^0xFFFFFF;}
ddr=10;}}//--Ввод через SPI;
};	//++++END class RT_HW_SPIhc165x3===============================================================
class RT_HW_SPIhc165x4{		//+++++КЛАСС УПРАВЛЕНИЯ RT_HW_SPIhc165x4===============================
public:
uint8_t  custom=0, run=0, cmdRun=1, ddr=0, initDevice=0, codeErr;  uint8_t fresh=0;
uint8_t  inv=0, bitOrder=1, cs=255; uint8_t bus=0; uint32_t speed=0;
uint32_t var;
//-------------------------------------------------------------------------------------------------
void setParam(uint8_t _inv, uint8_t _bitOrder, uint8_t _cs, uint8_t _bus=0, uint32_t _speed=0){//++++Установка параметров;
inv=_inv; bitOrder=_bitOrder; cs=_cs; bus=_bus; speed=_speed; custom=1;};	
void direct(){
//-------------------------------------------------------------------------------------------------
if(ddr== 0){if(custom!=1){return;} initDevice=0; ddr=10;}	//--Инициализация;
if(ddr==10){if(!run){return;} if(!initDevice){ddr=20;} else{ddr=30;}}	//--Выбор продолжения;
//-------------------------------------------------------------------------------------------------
if(ddr==20){	
if(!RT_HW_Base.SPIinitDevice(codeErr,cs,bus)){return;}  //--Инициализация шины с проверкой CS;
if(codeErr){ddr=10; codeErr=80; return;} else{initDevice=1; ddr=30;}} 
//-------------------------------------------------------------------------------------------------
if(ddr==30){
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs);	
RT_HW_Base.spiBeginTransaction(speed, bitOrder,0,bus);		
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS);
var=(uint32_t)RT_HW_Base.spiRead(bus)<<24; var=var+(((uint32_t)RT_HW_Base.spiRead(bus))<<16); var=var+(((uint32_t)RT_HW_Base.spiRead(bus))<<8); var=var+(uint8_t)RT_HW_Base.spiRead(bus);
RT_HW_Base.spiEndTransaction(bus);
if(inv){var=var^0xFFFFFFFF;}
ddr=10;}}//--Ввод через SPI;
};	//++++END class RT_HW_SPIhc165x4===============================================================

class RT_HW_SPNhc165  {		//+++++КЛАСС УПРАВЛЕНИЯ RT_HW_SPNhc165=================================
public:
RT_HW_STRUCT_SPN spn;
uint8_t  custom=0, run=0, cmdRun=1, ddr=0, initDevice=0, codeErr;  uint8_t fresh=0;
uint8_t  inv=0, bitOrder=1; uint8_t speed=0; uint8_t rx;
uint8_t  var;
//-------------------------------------------------------------------------------------------------
void setParam(uint8_t bitOrder, uint8_t sck, uint8_t mosi, uint8_t cs, uint8_t speed=0){//++++Установка параметров;
 bitOrder=bitOrder; spn.idSCK.pin=sck; spn.idMISO.pin=255; spn.idMOSI.pin=mosi; spn.idCS.pin=cs; spn.speed=speed; custom=1;};	
void direct(){
//-------------------------------------------------------------------------------------------------
if(ddr== 0){if(custom!=1){return;} initDevice=0; ddr=10;}	//--Инициализация;
if(ddr==10){if(!run){return;} if(!initDevice){ddr=20;} else{ddr=30;}}	//--Выбор продолжения;
//-------------------------------------------------------------------------------------------------
if(ddr==20){	
RT_HW_Base.SPNinitDevice(spn,codeErr); //--Инициализация шины с проверкой CS;
if(spn.status==1){initDevice=1; ddr=30;} else{ddr=90;}} 
//-------------------------------------------------------------------------------------------------
if(ddr==30){
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,spn.idCS.pin);			
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS);
RT_HW_Base.spnRead(spn,bitOrder,rx); var=rx;
if(inv){var=var^0xFF;}
fresh=1; ddr=10;}}//--Ввод через SPI;
};	//++++END class RT_HW_SPN_HC595================================================================

#endif
//=================================================================================================
